fn createPods splObj minPrecision PHeight PBase PWidthC PWidthB material texLen = 
(
	h1= PBase
	h2= PHeight
	w1= PWidthB
	w2= PWidthC
	tu1= 0
	tu2= 0.5*((w1-w2)/w1)
	tu3= 1-0.5*((w1-w2)/w1)
	tu4= 1

	lenArray= getSegLengths splObj 1
	len= lenArray[2]
	numSegs= ((len/minPrecision) as integer ) as float
	v1= tangentCurve3d splObj 1 0
	p1= interpCurve3d splObj 1 0
	if (numSegs<1) then
		numSegs= 1
--	obj= (mesh pos:p1 length:len width:2 lengthsegs:numSegs widthsegs:3)
	verts= #()
	tvertices= #()
	fcs= #()
	for i=0 to numSegs do
	(
		v1= tangentCurve3d splObj 1 (((i as float)/numSegs))
		p1= interpCurve3d splObj 1 (((i as float)/numSegs))
		v1side= (cross v1 z_axis)
		verts[(i)*4+1]= p1+(v1side*w1)+(point3 0 0 h1)
		verts[(i)*4+4]= p1-(v1side*w1)+(point3 0 0 h1)
		
		--tv= (len/texLen)*((i as float)/numSegs)
		--tvertices[(i)*4+1]= (point3 tu1 tv 0)
		--tvertices[(i)*4+2]= (point3 tu2 tv 0)
		--tvertices[(i)*4+3]= (point3 tu3 tv 0)
		--tvertices[(i)*4+4]= (point3 tu4 tv 0)

	)
	for i=1 to numSegs do
	(
		fcs[(i-1)*6+1]= (point3 ((i-1)*4+1) ((i)*4+1) ((i-1)*4+2) )
		fcs[(i-1)*6+2]= (point3 ((i-1)*4+2) ((i)*4+1) ((i)*4+2) )
		fcs[(i-1)*6+3]= (point3 ((i-1)*4+2) ((i)*4+2) ((i-1)*4+3) )
		fcs[(i-1)*6+4]= (point3 ((i-1)*4+3) ((i)*4+2) ((i)*4+3) )
		fcs[(i-1)*6+5]= (point3 ((i-1)*4+3) ((i)*4+3) ((i-1)*4+4) )
		fcs[(i-1)*6+6]= (point3 ((i-1)*4+4) ((i)*4+3) ((i)*4+4) )
		
	)
	
	disableSceneRedraw()
	obj= ( polyop vertices:verts faces:fcs tverts:tvertices material:material)
	for i=1 to obj.numFaces do
	(
		mod= i-((i-1)/6)*6
		if (mod<3 or mod>4) then
			setFaceSmoothGroup obj i 1
		else
			setFaceSmoothGroup obj i 2
	)
	obj.wireColor= (color 32 32 156)
	buildTVFaces obj
	for f = 1 to obj.numfaces do 
	setTVFace obj f (getface obj f) 

	update obj
	enableSceneRedraw()
	
)

rollout CreateNewStrew "Stwrz nasyp / wykop"
(
	spinner spnPods "Dugo segmentu" range:[5,100,5] scale:1 type:#float fieldwidth:30 
	spinner spnPodsH "Wysoko od toru" range:[-2,2,-0.2] scale:0.1 type:#float fieldwidth:35 across:2
	spinner spnPodsB "Wysoko H3" range:[-20,20,-0.5] scale:1 type:#float fieldwidth:35 
	spinner spnPodsWC "Szeroko H1" range:[1,10,2] scale:0.1 type:#float fieldwidth:35 across:2
	spinner spnPodsWB "Szeroko H2" range:[2,50,4] scale:0.1 type:#float fieldwidth:35 
	materialbutton mbTrackMat "Material" 
	spinner spnTexLen "Dugo tekstury" range:[1,1000,4] scale:1 type:#float
	pickbutton btn0 "Create" filter:shapeFilt

	on btn0 picked obj do
	(
		createPods obj spnPods.value spnPodsH.value spnPodsB.value spnPodsWC.value spnPodsWB.value mbTrackMat.material spnTexLen.value
	)
)