

	
fn getPointDir viewPoint worldPoint gridPoint currentNode=
(
			box= (box2  (viewPoint+[5,5,5]) (viewPoint-[5,5,5]) )
			arr= (boxPickNode box)
			wpt= worldPoint
				
			n=0
			minDist= 10000
			minPt= gridPoint+[0,0,0,0]
			minDir= [0,1,0]
			for node in arr do
			(
				if (currentNode!=node) and (SuperClassOf node == shape) then
					if  ((getUserProp node "Type")=="normal") or ((getUserProp node "Type")=="switch") then
					(
						print (getUserProp node "Type")
						convertToSplineShape node
						for i=1 to (numSplines node) do
						(
							nk= (numKnots node i)
							
							pt= getKnotPoint node i 1
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i 1)==#line) then
									minDir= pt - (getKnotPoint node i 2)
								else
									minDir= pt - (getOutVec node i 1)
								
							)

							pt= getKnotPoint node i nk
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i (nk-1))==#line) then
									minDir= pt - (getKnotPoint node i (nk-1))
								else
									minDir= pt - (getInVec node i nk)
							)

						)
					)
			)
			minDir= (normalize minDir)
			print "getPointDir:"
			print minPt
			print minDir
			#(minPt,minDir)
)

fn AddNewTrack minPt minDir type sort nodeName length direction radius totalangle trackslope trackslope2=
(
	disableSceneRedraw()
--				prosta
				if (type==1) then
				(
					l= line name:nodeName pos:minPt	
					minDir.z= 0
					addNewSpline l
					addKnot l 1 #smooth #line minPt
					addKnot l 1 #smooth #line (minPt+minDir*length+[0,0,trackslope*length/1000])
					updateShape l
					track= l
				)
--				Luk poziomy
				else if (type == 2 and sort == 1) then
				(
					vec= normalize (cross z_axis minDir)
					if (direction==2) then 
						pt= minPt-vec*radius
					else
						pt= minPt+vec*radius
					dir= minDir
					dir.z=0
					dir= normalize dir
					if (dir.x!=0) then
						angle= atan (dir.y/dir.x)
					else
						if (dir.y>0) then
							angle= 90
						else
							angle= -90
					if (dir.x<0) then
						if (dir.y<0) then
							angle= angle-180
						else
							angle= 180+angle
					Format "angle: %\n" angle
					if (totalangle>0) then
						ang= totalangle*3
					else
						ang= (length*180*3)/(pi*radius)
					if (ang>270) then
						ang= 270
--					prawo
					if (direction==2) then 
					(
						ato= angle+90
						afrom= ato-ang
					)
--					lewo
					else
					(
						afrom= angle-90 
						ato= afrom+ang
					)
					
					if (afrom<0) then
					(
						afrom= afrom+360
					)
					if (ato<0) then
						ato= ato+360
					if (ato>360) then
						ato= ato-360
					print afrom
					print ato
					print radius
					a= arc name:nodeName pos:pt radius:radius from:afrom to:ato
					convertToSplineShape a
--					print (numKnots a 1)
					if (direction==1) then 
					(
						deleteKnot a 1 (numKnots a 1)
						deleteKnot a 1 (numKnots a 1)
						updateShape a
					)
					else
					(
						deleteKnot a 1 1
						deleteKnot a 1 1
						reverse a 1
						updateShape a
						
					)
--					print (numKnots a 1)
					convertToSplineShape a;
--					print "poprawki na wzniesienie"
					l= curveLength a
					pt= (getKnotPoint a 1 2)
--					print "pt.z"
--					print l
--					print (curveLength a)
--					print (l*trackslope/1000)
--					print pt.z
					pt.z+= l*trackslope/1000
--					print pt.z
					setKnotPoint a 1 2 pt
					updateShape a
					pt= (getOutVec a 1 1) - (getKnotPoint a 1 1)
					pt_x= pt.x*pt.x
					pt_y= pt.y*pt.y
					dlVec= sqrt (pt_x+pt_y)
--					print "wart1"
--					print pt.x
--					print pt.y
--					print dlVec
--					print (dlVec*trackslope/1000)
					pt.z= dlVec*trackslope/1000*1.0
					pt+= (getKnotPoint a 1 1)
					setOutVec a 1 1 pt
					updateShape a
					pt= (getInVec a 1 2) - (getKnotPoint a 1 2)
					pt_x= pt.x*pt.x
					pt_y= pt.y*pt.y
					dlVec= sqrt (pt_x+pt_y)
--					print "wart2"
--					print (getKnotPoint a 1 2)
--					print (getInVec a 1 2)
--					print pt
--					print dlVec
--					print (dlVec*trackslope/1000)
					pt.z= -dlVec*trackslope/1000*2
--					print pt
					pt+= (getKnotPoint a 1 2)
--					print pt
					setInVec a 1 2 pt
					updateShape a
--					print (numKnots a 1)
--					print (numSplines a)
					track= a
					
				)
	enableSceneRedraw()
	
	return track
)

fn AddFlexTrack minPt minDir nodeName minPt2 minDir2 =
(
	print "AddFlexTrack"
	disableSceneRedraw()
	l= line name:nodeName pos:minPt
	len= (distance  minPt minPt2)/3
	addNewSpline l
	addKnot l 1 #bezier #curve minPt minPt (minPt+minDir*len)
	addKnot l 1 #bezier #curve minPt2 (minPt2+minDir2*len) minPt2
	updateShape l
	track= l
	enableSceneRedraw()
	
	return track
)

fn AddVerticalArcTrack minPt1 minDir1 nodeName minPt2 minDir2 =
(
	disableSceneRedraw()
	l= line name:nodeName pos:minPt1
	--len= (distance  minPt minPt2)/3
	addNewSpline l
	--	sh	num	type	type leave	pos	invec	outvec
	addKnot l 1 #bezier #curve minPt1 minPt1 (minPt1+minDir1)
	addKnot l 1 #bezier #curve minPt2 (minPt2+minDir2) minPt2
	updateShape l
	track= l
	enableSceneRedraw()
	return track
)

fn shapeFilt o = superClassOf o == Shape 

rollout CreateNormalTrack "Stworz nowy tor"
(
	local tr
	editText eName "Nazwa" text:"tor" 
	radioButtons rbType "Typ" labels:#(#Prosta,#Luk,#Flex) align:#left
	radioButtons rbVerticalOrHorizontal "Rodzaj" labels:#(#Poziomy,#Pionowy) align:#left across:2 enabled:false
	radioButtons rbDirection "Odchylenie" labels:#(#Lewo, #Prawo) enabled:false align:#left
	checkbox cbKrzywaPrzejsciowa "Zastosuj krzywa przejciowa" checked:false enabled:false
	spinner spnRoll1 "Roll 1" range:[-45,45,0] align:#left width:128 across:2
	spinner spnRoll2 "Roll 2" range:[-45,45,0] align:#left width:128
	spinner spnATow "Przys niezr tow" range:[0,2,0.6] align:#left enabled:false width:100 across:2
	spinner spnADop "Przys niezr dop" range:[0,2,0.8] align:#left enabled:false width:100
	spinner spnLength "DLugoc" range:[0.2,500,100] align:#left width:140 across:4
	button btndl1 "10" align:#right
	button btndl2 "100" align:#center
	button btndl3 "400" align:#left
	spinner spnRadius "Promien" range:[10,20000,300] enabled:false align:#left width:128
	spinner spnAngle "Kat" range:[0,90,45] enabled:false align:#left
	spinner spnSlope "Pochylenie 1 w " range:[-50,50,0] align:#left width:100 across:2
	spinner spnSlope2 "Pochylenie 2 w " range:[-50,50,0] align:#right width:100 enabled:false
	editText eMaxdist "MaxDistance" text:"-1"  across:3
	editText eMindist "MinDistance" text:"0"
	editText eParam1 "Szer. torow" text:"1.435" align:#right 
	editText eParam2 "Friction" text:"0.25" across:2
	editText eParam3 "SoundDist" text:"25.0" 
	editText eParam4 "Quality" text:"20" across:2
	editText eParam5 "DamageFlag" text:"0" 
	radioButtons rbEnvironment "Otoczenie" labels:#(#PLaskie, #Nadbrzeze, #Most, #Gory, #Kanion, #Tunel) align:#left columns:3
	editText eParam7 "Widocznoc" text:"vis" across:2
	editText eParam9 "DL. tex" text:"4.55" width:80
	dropdownlist eParam8 "Tex1" items:#("rail_screw_reused1", "rail_screw_rused1", "rail_screw_rused2", "rail_screw_unused1", "rail_screw_unused2", "rail_screw_used1", "rail_screw_used2", "none") across:2
	dropdownlist eParam10 "Tex2" items:#("tory/1435/tpd-469-1" , "tory/1435/tpd-469-2" , "tory/1435/tpd-469-3" , "tory/1435/tpd-469-4" , "tory/1435/tpd-469-5" , "1435mm/tpbps-new2", "1435mm/tpbps-new2-699", "1435mm/tpb-stone1-new", "1435mm/tpb-stone1-oil", "1435mm/tpb-stone2-new", "1435mm/tpb-stone2-oil", "1435mm/tpb-stone2-used", "1435mm/tpb-stone3-new", "1435mm/tpb-stone3-oil", "1435mm/tpb-stone3-thick", "1435mm/tpb-stone4-oil", "1435mm/tpb-stone4-old", "1435mm/tpb-stone4-old2", "1435mm/tpb-stone4-used", "1435mm/tpd-stare_skp", "1435mm/tpd-stone1-new", "1435mm/tpd-stone1-oil", "1435mm/tpd-stone1-used", "1435mm/tpd-stone2-new", "1435mm/tpd-stone2-oil", "1435mm/tpd-stone2-old", "1435mm/tpd-stone2-used", "1435mm/tpd-stone3-new", "1435mm/tpd-stone3-oil", "1435mm/tpd-stone3-thick", "1435mm/tpd-stone3-used", "1435mm/tpd-stone4-oil", "1435mm/tpd-stone4-old", "1435mm/tpd-stone4-old2", "1435mm/tpd-stone4-old3", "1435mm/tpd-stone4-thick", "1435mm/tpd-stone4-used","none")
	editText eParam11 "Wys. tex" text:"0.35" across:3
	editText eParam12 "Szer. tex" text:"0.7825" 
	editText eParam13 "TexSlope" text:"0.525" 
	group "Eventy"
	(
	editText eEvent0 "Event0" text:""
	editText eEvent1 "Event1" text:""
	editText eEvent2 "Event2" text:""
	editText eEventall1 "Eventall1" text:""
	editText eEventall2 "Eventall2" text:""
	)
	editText eIsolated "Tor izolowany(nazwa)" text:""
	spinner spnVelocity "Szybkoc" range:[-1,500,-1] scale:1 type:#float align:#left
	button btn1 "Stworz"
	button btn1add "Dodaj do poprzedniego" enabled:false


	on CreateNormalTrack open do
 	(
	

	nr = getINISetting (scriptDirectory+"ustawienia.ini" ) "tory" "Tex1"
	if nr != "" then eParam8.selection = (nr as integer)	
	else eParam8.selection = 1
		
	
	nr = getINISetting (scriptDirectory+"ustawienia.ini" ) "tory" "Tex2"
	if nr != "" then eParam10.selection = (nr as integer)
	else eParam10.selection = 1	
	
 	
	)	
	
	on eParam8 selected nr do 
	(
	setINISetting (scriptDirectory+"ustawienia.ini") "tory" "Tex1" (nr as string)
	)
	
	on eParam10 selected nr do 
	(
	setINISetting (scriptDirectory+"ustawienia.ini") "tory" "Tex2" (nr as string)
	)
	
	
	
	fn AddUniqueName=
	(		
		local nodeName
		if (eName.text=="") then
			nodeName= "none"
		else
			if (getNodeByName eName.text)==undefined then
				nodeName= eName.text
			else
				nodeName= uniqueName eName.text
		return nodeName
	)
--adduniquename

	fn fixLength= 
	(
--		print "fixLength"
		l= curveLength tr
--		print "dlugosc"
--		print l
		if (l>100) then
		(
			n= ceil (l/100)
			print n
			subdivideSegment tr 1 1 (n-1)
			newl = l/n
--			print "nadawaniePoPodzieleniu"
--			print newl
--			setUserProp tr "Length" (newl as string)
			updateShape tr
			for i=1 to n-1 do
			(
				spl= copy tr
				spl.name= AddUniqueName()
				setUserPropBuffer spl (getUserPropBuffer tr)
				j=(numKnots spl 1)
				while (j>=1) do
				(
					if (j!=i and j!=i+1) then
						deleteKnot spl 1 j
					j-= 1
				)
				spl.wireColor= (color 8 8 136)
				updateShape spl
				l= curveLength spl
				print l
				setUserProp spl "Length" (l as string)
--				print "wart2"
--				print ((getInVec spl 1 2) - (getKnotPoint spl 1 2))
			)
			j=(numKnots tr 1)
			while (j>=1) do
			(
				if (j!=n and j!=n+1) then
					deleteKnot tr 1 j
				j-= 1
			)
			print (curveLength tr)
			setUserProp tr "Length" ((curveLength tr) as string)
--			print "wart2"
--			print ((getInVec tr 1 2) - (getKnotPoint tr 1 2))
			tr.wireColor= (color 8 8 128)
			updateShape tr
--			delete tr
			print "fixed"
			print tr
		)
		 else
		(
--			print "nadawanieBezDzielenia"
			setUserProp tr "Length" (l as string)
		)
	)

	fn AddPropToTrack roll1 roll2 radius=
	(
				setUserProp tr "Type" "normal"
				setUserProp tr "Radius1" (radius as string)
				setUserProp tr "Roll1" (roll1 as string)
				setUserProp tr "Roll2" (roll2 as string)
				setUserProp tr "MaxDist" eMaxdist.text
				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "TrackWidth" eParam1.text
				setUserProp tr "Friction" eParam2.text
				setUserProp tr "SoundDist" eParam3.text
				setUserProp tr "Quality" eParam4.text
				setUserProp tr "DamageFlag" eParam5.text
--				setUserProp tr "Environment" eParam6.text
				case rbEnvironment.state of
				(
					1:
					(
				    	setUserProp tr "Environment" "Flat"
				   	)
					2:
					(
				    	setUserProp tr "Environment" "Bank"
				   	)
					3:
				   	(
				    	setUserProp tr "Environment" "Bridge"
				   	)
				  	4:
				   	(
				    	setUserProp tr "Environment" "Mountains"
				   	)
				  	5:
				   	(
				    	setUserProp tr "Environment" "Canyon"
				   	)
				  	6:
				   	(
				    	setUserProp tr "Environment" "Tunnel"
				   	)
				)				
				setUserProp tr "Visibility" eParam7.text
				setUserProp tr "Tex1" eParam8.text
				setUserProp tr "TexLength" eParam9.text
				setUserProp tr "Tex2" eParam10.text
				setUserProp tr "TexPar1" eParam11.text
				setUserProp tr "TexPar2" eParam12.text
				setUserProp tr "TexPar3" eParam13.text
				
				if (eEvent0.text!="") then
					setUserProp tr "Event0" eEvent0.text
				if (eEvent1.text!="") then
					setUserProp tr "Event1" eEvent1.text
				if (eEvent2.text!="") then
					setUserProp tr "Event2" eEvent2.text

				if (eEventall1.text!="") then
					setUserProp tr "Eventall1" eEventall1.text
					
				if (eEventall2.text!="") then
					setUserProp tr "Eventall2" eEventall2.text
					
				if (spnVelocity.value>=0) then
				(
					setUserProp tr "Velocity" (spnVelocity.value as string)
				)
				if (eIsolated.text != "" ) then
				(
					setUserProp tr "Isolated" (eIsolated.text as string)
				)
				
				tr.wireColor= (color 8 8 136)
				if (rbType.state!=3) then
				(
					fixLength()
				)
	)
--addproptotrack

	fn GetPointOfLastTrack=
	(		
		local Pt1,Dir1
		minPt= [0,0,0.2]
		minDir= [0,1,0]
		convertToSplineShape tr
		minPt= getKnotPoint tr 1 2
		if ((getSegmentType tr 1 1)==#line) then
			minDir= minPt - (getKnotPoint tr 1 1)
		else
			minDir= minPt - (getInVec tr 1 2)							
		minDir= (normalize minDir)
		local pt
		pt= #()
		pt[1] = minPt
		pt[2] = minDir
		return pt
	)
--getpointoflasttrack

	tool CreateTrack
	( 
		local nodeName
		local Pt1,Dir1
--		local tr
        local r1= spnRadius.value
		local v= spnVelocity.value
		local aTow = spnATow.value
		local aDop = spnADop.value
		local slopeBak -- zeby zapamietac pochylenie
		local roll1,roll2,roll3
		local lkp, tg, rollMin,rollMax,rollAvg
		on mousePoint clickno do 
			-- pierwsze klikniecie
			if clickno != 2 then
			(
				print (Format "Nr klikniecia: % " clickno)
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
				print (Format "getPointDir pt: % dir: %" ptArr[1] ptArr[2])
				if (rbVerticalOrHorizontal.state==1 and cbKrzywaPrzejsciowa.checked) then
				(
					print "Obliczenie przechyLki"
					rollMin = 11.8*v^2/r1-1.435/9.81*aTow
					rollMax = 11.8*v^2/r1-1.435/9.81*aDop
					rollAvg = (rollMin+rollMax)/2
/*					print rollMin
					print rollMax
					print rollAvg/**/
					stopnie = atan (rollAvg/1435)
					print (Format "przechyLka w stopniach: % " stopnie)
					roll3 = stopnie
					roll2 = roll3/2					
					roll1 = 0
/*					print roll3
					print roll2
					print roll1/**/
--					przeliczenia dlugosci krzywej
					lkp = 11.8*v^3/100/r1
					luk = spnLength.value - lkp
					lkp2 = lkp/2
					lkpSt = (lkp2/r1)*180/pi
					lukSt = spnAngle.value - lkpSt*2
					if (lukSt < 0) then
					(
						local lkpTmp, rollTmp
						lkpTmp = spnAngle.value / 2
						rollTmp = roll2*lkpTmp/lkpSt
						roll3 = roll2 + rollTmp
						lkpSt = lkpTmp
					)
--					print lkp
--					print lkp2
--					print lkpSt
--					print lukSt
				)
				else
				(
					roll1 = spnRoll1.value
					roll2 = spnRoll2.value
					roll3 = 0
				)
                if (rbType.state==2 and rbVerticalOrHorizontal.state==1) then
				(
--					zakret w prawo
					if (rbDirection.state==2) then
					(
		 				r1= -r1
--						poprawka na zakret, zeby dobrze przechylaL
						if (roll1 < 0) then
							roll1 = -roll1
						if (roll2 < 0) then
							roll2 = -roll2
						if (roll3 < 0) then
							roll3 = -roll3
			 		)
--					zakret w lewo
					else
					(
						if (roll1 > 0) then
							roll1 = -roll1
						if (roll2 > 0) then
							roll2 = -roll2
						if (roll3 > 0) then
							roll3 = -roll3
					)
				)
				else
				(
  					r1= 0
				)

				if (rbType.state==3) then
				(
					print "Dodawanie flex'a"
					nodeName = AddUniqueName()
					Pt1= ptArr[1]
					Dir1= ptArr[2]
					slopeBak = spnSlope.value
                    spnSlope.value= 0
					tr= (AddFlexTrack Pt1 Dir1 (nodeName) Pt1 Dir1)
					spnSlope.value = slopeBak
				)
				else
				(
--					luk z krzywa przejsciowa
					if (rbType.state==2 and rbVerticalOrHorizontal.state==1 and cbKrzywaPrzejsciowa.checked) then
					(
						--prost lkp
						nodeName = AddUniqueName()
						tr = (AddNewTrack ptArr[1] ptArr[2] 1 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value spnAngle.value spnSlope.value #undefined)
						AddPropToTrack roll1 roll2 0
						--krzywa lkp
						pt = GetPointOfLastTrack()
						nodeName = AddUniqueName()
						tr = (AddNewTrack pt[1] pt[2] 2 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value lkpSt spnSlope.value #undefined)
						AddPropToTrack roll2 roll3 r1
						--luk
						if (luk > 0) then
						(
							pt = GetPointOfLastTrack()
							nodeName = AddUniqueName()
							tr = (AddNewTrack pt[1] pt[2] 2 rbVerticalOrHorizontal.state (nodeName) luk rbDirection.state spnRadius.value lukSt spnSlope.value #undefined)
							AddPropToTrack roll3 roll3 r1
						)
						--krzywa lkp
						pt = GetPointOfLastTrack()
						nodeName = AddUniqueName()
						tr = (AddNewTrack pt[1] pt[2] 2 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value lkpSt spnSlope.value #undefined)
						AddPropToTrack roll3 roll2 r1
						--prosta lkp
						pt = GetPointOfLastTrack()
						nodeName = AddUniqueName()
						tr = (AddNewTrack pt[1] pt[2] 1 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value spnAngle.value spnSlope.value #undefined)
						AddPropToTrack roll2 roll1 0
					)
--					luk bez krzywej przejsciowej lub prosta lub bez zmiany pochylenia
					else if ((rbType.state==2 and rbVerticalOrHorizontal.state==1) or rbType.state == 1) then
					(
						nodeName = AddUniqueName()
						tr= (AddNewTrack ptArr[1] ptArr[2] rbType.state rbVerticalOrHorizontal.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value spnSlope.value spnSlope2.value)						
						AddPropToTrack roll2 roll1 r1
					)
--					luk pionowy
					else
					(
						print "Luk pionowy"
						local poch,kat,Pt1,Dir1,Pt2,Dir2
						poch = spnSlope2.value - spnSlope.value
						kat = radToDeg(tan (radToDeg((abs poch) / 1000f)))
						Ldoc = (4 / 3f) * tan (kat / 4) * spnRadius.value
						Pt1 = ptArr[1]
						Dir1 = ptArr[2]*Ldoc
						Dir1[3] = Ldoc * spnSlope.value / 1000f
						T = spnRadius.value * tan (kat / 2)
						Pt2 = (Pt1+(ptArr[2]*2*T))
						Pt2[3] = Pt1[3] + (spnSlope.value + spnSlope2.value)*T/1000f
						Dir2 = -Dir1
						Dir2[3] = -Ldoc * (spnSlope2.value / 1000f)
						/*print (Format "Zmienne Ldoc: % T: %" Ldoc T)
						print (Format "Punkty 1 pt1: % dir1: %" Pt1 Dir1)
						print (Format "Punkty 2 pt2: % dir2: %" Pt2 Dir2)
						print (Format "OdlegLoc: % 2*T: %" (distance Pt1 Pt2) (2*T))/**/
						nodeName = AddUniqueName()
						tr = (AddVerticalArcTrack Pt1 Dir1 (nodeName) Pt2 Dir2)
						AddPropToTrack roll2 roll1 0
					)
				)
			)
			else
				if (rbType.state==3) then
				(
					fixLength()
					#stop
				)

		on mouseMove clickno do
		(
--			print clickno
			if (rbType.state==3) then
			(
				ptArr= (getPointDir viewPoint worldPoint gridPoint tr)
				len= (distance Pt1 ptArr[1])/3
				setKnotPoint tr 1 2 ptArr[1]
				setInVec tr 1 2 (ptArr[1]+ptArr[2]*len)
				setOutVec tr 1 2 ptArr[1]
				setOutVec tr 1 1 (Pt1+Dir1*len)
				updateShape tr
				AddPropToTrack roll1 roll2 0
--				fixLength()
			)
		)
	) 

--createtrack
	fn AddTrack =
	( 
		print "add track"
		local newtr
		local nodeName
      	local r1= spnRadius.value
		local roll1,roll2,roll3
		local v= spnVelocity.value
		local aTow = spnATow.value
		local aDop = spnADop.value
		local lkp, tg, rollMin,rollMax,rollAvg
		nodeName = AddUniqueName()
		
        if (rbType.state==2 and rbVerticalOrHorizontal.state==1) then
		(
			if (cbKrzywaPrzejsciowa.checked) then
			(
				print "roznosci"
				rollMin = 11.8*v^2/r1-1.435/9.81*aTow
				rollMax = 11.8*v^2/r1-1.435/9.81*aDop
				rollAvg = (rollMin+rollMax)/2
				print rollMin
				print rollMax
				print rollAvg
				tg = (tan (rollAvg/1435))*180/pi
--				print tg
				roll3 = (tg*180)/(pi)
				roll2 = roll3/2					
				roll1 = 0
--				print roll3
--				print roll2
--				print roll1
--				przeliczenia dlugosci krzywej
				lkp = 11.8*v^3/100/r1
				luk = spnLength.value - lkp
				lkp2 = lkp/2
				lkpSt = (lkp2/r1)*180/pi
				lukSt = spnAngle.value - lkpSt*2
				if (lukSt < 0) then
				(
					local lkpTmp, rollTmp
					lkpTmp = spnAngle.value / 2
					rollTmp = roll2*lkpTmp/lkpSt
					roll3 = roll2 + rollTmp
					lkpSt = lkpTmp
				)
--				print lkp
--				print lkp2
--				print lkpSt
--				print lukSt
			)
			else
			(
				roll1 = spnRoll1.value
				roll2 = spnRoll2.value
				roll3 = 0
			)
--			zakret w prawo		
			if (rbDirection.state==2) then
			(
--				poprawka na zakret, zeby dobrze przechylaL
				if (roll1 < 0) then
					roll1 = -roll1
				if (roll2 < 0) then
					roll2 = -roll2
				r1= -r1
	 		)
--			zakret w lewo
			else
			(
				if (roll1 > 0) then
					roll1 = -roll1
				if (roll2 > 0) then
					roll2 = -roll2
			)
		)
		else
		(
			r1= 0
			roll1 = spnRoll1.value
			roll2 = spnRoll2.value
		)
		pt = GetPointOfLastTrack()
		if (rbType.state == 2 and rbVerticalOrHorizontal.state==1 and cbKrzywaPrzejsciowa.checked) then
		(
			--prost lkp
			nodeName = AddUniqueName()
			tr = (AddNewTrack pt[1] pt[2] 1 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value spnAngle.value spnSlope.value #undefined)
			AddPropToTrack roll1 roll2 0
			--krzywa lkp
			pt = GetPointOfLastTrack()
			nodeName = AddUniqueName()
			tr = (AddNewTrack pt[1] pt[2] 2 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value lkpSt spnSlope.value #undefined)
			AddPropToTrack roll2 roll3 r1
			--luk
			if (luk > 0) then
			(
				pt = GetPointOfLastTrack()
				nodeName = AddUniqueName()
				tr = (AddNewTrack pt[1] pt[2] 2 rbVerticalOrHorizontal.state (nodeName) luk rbDirection.state spnRadius.value lukSt spnSlope.value #undefined)
				AddPropToTrack roll3 roll3 r1
			)
			--krzywa lkp
			pt = GetPointOfLastTrack()
			nodeName = AddUniqueName()
			tr = (AddNewTrack pt[1] pt[2] 2 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value lkpSt spnSlope.value #undefined)
			AddPropToTrack roll3 roll2 r1
			--prosta lkp
			pt = GetPointOfLastTrack()
			nodeName = AddUniqueName()
			tr = (AddNewTrack pt[1] pt[2] 1 rbVerticalOrHorizontal.state (nodeName) lkp2 rbDirection.state spnRadius.value spnAngle.value spnSlope.value #undefined)
			AddPropToTrack roll2 roll1 0
		)
--		luk bez krzywej przejsciowej lub prosta lub bez zmiany pochylenia
		else if ((rbType.state==2 and rbVerticalOrHorizontal.state==1) or rbType.state == 1) then
		(
			nodeName = AddUniqueName()
			tr= (AddNewTrack pt[1] pt[2] rbType.state rbVerticalOrHorizontal.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value spnSlope.value spnSlope2.value)
			AddPropToTrack roll2 roll1 r1
		)
--		luk pionowy
		else
		(
			print "Luk pionowy"
			local poch,kat,Pt1,Dir1,Pt2,Dir2
			poch = spnSlope2.value - spnSlope.value
			kat = radToDeg(tan (radToDeg((abs poch) / 1000f)))
			Ldoc = (4 / 3f) * tan (kat / 4) * spnRadius.value
			Pt1 = pt[1]
			Dir1 = pt[2]*Ldoc
			Dir1[3] = Ldoc * spnSlope.value / 1000f
			T = spnRadius.value * tan (kat / 2)
			Pt2 = (Pt1+(pt[2]*2*T))
			Pt2[3] = Pt1[3] + (spnSlope.value + spnSlope2.value)*T/1000f
			Dir2 = -Dir1
			Dir2[3] = -Ldoc * (spnSlope2.value / 1000f)
			/*print (Format "Zmienne Ldoc: % T: %" Ldoc T)
			print (Format "Punkty 1 pt1: % dir1: %" Pt1 Dir1)
			print (Format "Punkty 2 pt2: % dir2: %" Pt2 Dir2)
			print (Format "OdlegLoc: % 2*T: %" (distance Pt1 Pt2) (2*T))/**/
			nodeName = AddUniqueName()
			tr = (AddVerticalArcTrack Pt1 Dir1 (nodeName) Pt2 Dir2)
			AddPropToTrack roll2 roll1 0
		)
	)
--addtrack

	on cbKrzywaPrzejsciowa changed checked do
	(
		case checked of
		(
			true:
			(
				spnATow.enabled= true
				spnADop.enabled= true
				spnRoll1.enabled= false
				spnRoll2.enabled= false
			)
			false:
			(
				spnATow.enabled= false
				spnADop.enabled= false
				spnRoll1.enabled= true
				spnRoll2.enabled= true
			)
		)
	)
				
	on rbVerticalOrHorizontal changed state do
	(
		case state of
		(
			1:
			(
				spnLength.enabled= true
				spnRadius.enabled= true
				spnAngle.enabled= true
				rbDirection.enabled= true
				spnSlope.enabled= true
				spnSlope2.enabled = false
				if (cbKrzywaPrzejsciowa.checked) then
				(
					spnATow.enabled= true
					spnADop.enabled= true
					spnRoll1.enabled= false
					spnRoll2.enabled= false
				)
				else
				(
					spnATow.enabled= false
					spnADop.enabled= false
					spnRoll1.enabled= true
					spnRoll2.enabled= true
				)
				cbKrzywaPrzejsciowa.enabled = true
			)
			2:
			(
				spnLength.enabled= false
				spnRadius.enabled= true
				spnAngle.enabled= false
				rbDirection.enabled= false
				spnSlope.enabled= true
				spnSlope2.enabled = true
				spnATow.enabled= false
				spnADop.enabled= false
				spnRoll1.enabled= true
				spnRoll2.enabled= true
				cbKrzywaPrzejsciowa.enabled = false
			)
		)
	)
				
	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnLength.enabled= true
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
				spnSlope.enabled= true
				spnSlope2.enabled = false
				spnATow.enabled= false
				spnADop.enabled= false
				spnRoll1.enabled= true
				spnRoll2.enabled= true
				cbKrzywaPrzejsciowa.enabled = false
				rbVerticalOrHorizontal.enabled = false
				btndl1.enabled=true
				btndl2.enabled=true
				btndl3.enabled=true
			)
			2:
			(
				spnLength.enabled= true
				spnRadius.enabled= true
				spnAngle.enabled= true
				rbDirection.enabled= true
				spnSlope.enabled= true
				spnSlope2.enabled = false
				if (cbKrzywaPrzejsciowa.checked) then
				(
					spnATow.enabled= true
					spnADop.enabled= true
					spnRoll1.enabled= false
					spnRoll2.enabled= false
				)
				else
				(
					spnATow.enabled= false
					spnADop.enabled= false
					spnRoll1.enabled= true
					spnRoll2.enabled= true
				)
				cbKrzywaPrzejsciowa.enabled = true
				rbVerticalOrHorizontal.enabled = true
			)
			3:
			(
				spnLength.enabled= false
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
				spnSlope.enabled= false
				spnSlope2.enabled = false
				spnATow.enabled= false
				spnADop.enabled= false
				spnRoll1.enabled= true
				spnRoll2.enabled= true
				cbKrzywaPrzejsciowa.enabled = false
				rbVerticalOrHorizontal.enabled = false
				btndl1.enabled=false
				btndl2.enabled=false
				btndl3.enabled=false
			)
		)
	)
	
		on btndl1 pressed do
	(
	spnLength.value = btndl1.text as float
	---startTool CreateTrack
	
	)
	
	on btndl2 pressed do
	(
	spnLength.value = btndl2.text as float
	--startTool CreateTrack
	
	)
	
	on btndl3 pressed do
	(
	spnLength.value = btndl3.text as float
	--startTool CreateTrack
	
	)

	on btn0 picked obj do
	(
		createPods obj spnPods.value spnPodsH.value spnPodsB.value spnPodsWC.value spnPodsWB.value mbTrackMat.material spnTexLen.value
	)
	on btn1 pressed do
	(
		startTool CreateTrack
		btn1add.enabled= true
	)
	on btn1add pressed do
	(
		if (rbType.state!=3) then
		 (
			if tr!=undefined and not (isDeleted tr) then
			(
	 			AddTrack()
--				fixLength()
			)
			else
				btn1add.enabled=false
		 )
	)
	on spnAngle changed value do
	     spnLength.value= spnRadius.value*spnAngle.value*pi/180
	on spnRadius changed value do
	     spnLength.value= spnRadius.value*spnAngle.value*pi/180
	on spnLength changed value do
          if (rbType.state==2) then
	     spnAngle.value= spnLength.value*180/(spnRadius.value*pi)
)


rollout CreateSwitch "Stworz zwrotnice"
(
	local tr
	editText eStationName "Nazwa stacji" text:"Test" bold:true        
	editText eSwitchNumber "Numer zwrotnicy" text:"1" bold:true    
	editText eName "Nazwa" text:"Test_zwr1" 
	radioButtons rbType "Typ" labels:#(#Linia, #Luk) align:#left across:2
	radioButtons rbDirection "Odchylenie" labels:#(#Lewo, #Prawo) align:#left
	spinner spnLength "DLugoc" range:[1,100,34] align:#left
	spinner spnRadius1 "Promien 1" range:[100,1200,300] enabled:false align:#left
	spinner spnRadius2 "Promien 2" range:[100,1200,300] align:#left
	editText eFileName "Ctrl. Include File" text:"ZwrL34R300.inc" 
	editText eTexture "Tex podkLadu" text:"zwrot34R300pods-new" 
	editText eMaxdist "MaxDistance" text:"-1"  across:3
	editText eMindist "MinDistance" text:"0"
	editText eParam1 "Szer. torow" text:"1.435" align:#right 
	editText eParam2 "Friction" text:"0.24" across:2
	editText eParam3 "SoundDist" text:"15.0" 
	editText eParam4 "Quality" text:"20" across:2
	editText eParam5 "DamageFlag" text:"2" 
	radioButtons rbEnvironment "Otoczenie" labels:#(#PLaskie, #Nadbrzeze, #Most, #Gory, #Kanion, #Tunel) align:#left columns:3
--	editText eParam6 "Environment" text:"flat" 
	editText eParam7 "Widocznoc" text:"vis" across:2
	editText eParam9 "DL. tex" text:"4"
--	editText eParam8 "Tex 1" text:"Rail_screw_rused1" 
--	editText eParam10 "Tex 2" text:"Rail_screw_rused1" 
	dropdownlist eParam8 "Tex1" items:#("rail_screw_reused1", "rail_screw_rused1", "rail_screw_rused2", "rail_screw_unused1", "rail_screw_unused2", "rail_screw_used1", "rail_screw_used2", "none") across:2
	dropdownlist eParam10 "Tex2" items:#("rail_screw_reused1", "rail_screw_rused1", "rail_screw_rused2", "rail_screw_unused1", "rail_screw_unused2", "rail_screw_used1", "rail_screw_used2", "none")
	editText eParam11 "TP1" text:"0.2" across:3
	editText eParam12 "TP2" text:"2.75" 
	editText eParam13 "TP3" text:"2.5" 
--	editText eEvent0 "Event0" text:""
--	editText eEvent1 "Event1" text:""
--	editText eEvent2 "Event2" text:""
	spinner spnVelocity "Szybkoc" range:[-1,500,-1] scale:1 type:#float align:#left
	button btn1 "Stworz"
	
	
	on CreateSwitch open do
 	(
	nr = getINISetting (scriptDirectory+"ustawienia.ini" ) "zwrotnice" "Tex1"
	if nr != "" then eParam8.selection = (nr as integer)	
	else eParam8.selection = 1
	
	nr = getINISetting (scriptDirectory+"ustawienia.ini" ) "zwrotnice" "Tex2"
	if nr != "" then eParam10.selection = (nr as integer)	
	else eParam10.selection = 1
	
	
	)	
	
	on eParam8 selected nr do 
	(
	setINISetting (scriptDirectory+"ustawienia.ini") "zwrotnice" "Tex1" (nr as string)
	)
	
	on eParam10 selected nr do 
	(
	setINISetting (scriptDirectory+"ustawienia.ini") "zwrotnice" "Tex2" (nr as string)
	)
	
	
	group "Najczeciej uzywane zwrotnice"
	(
		button zBt1 "L 25 R 190" across:2
		button zBt2 "P 25 R 190"
		button zBt3 "L 34 R 300" across:2
		button zBt4 "P 34 R 300"
		button zBt5 "L 65 R 1200" across:2
		button zBt6 "P 65 R 1200" 
		button zBt7 "Y 34 R 300" across:2
		button zBt8 "K 34 R 150" 
	)
	group "Zwrotnica krzyzowa K 34 R 190"
	(
		dropdownlist StrewParam items:#("TpD1", "TpD2", "TpD-oil2") across:2
		button zBt9 "K 34 R 190"
	)

	fn AddUniqueName=
	(		
		local nodeName
		if (eName.text=="") then
			nodeName= "none"
		else
			if (getNodeByName eName.text)==undefined then
				nodeName= eName.text
			else
				nodeName= uniqueName eName.text
		return nodeName
	)
--adduniquename

	fn fixLength= 
	(
		l= curveLength tr
		setUserProp tr "Length" (l as string)
	)
	
	fn AddPropToTrack roll1 roll2 radius=
	(
				setUserProp tr "Type" "normal"
				setUserProp tr "Radius1" (radius as string)
				setUserProp tr "Roll1" (roll1 as string)
				setUserProp tr "Roll2" (roll2 as string)
				setUserProp tr "MaxDist" eMaxdist.text
				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "TrackWidth" eParam1.text
				setUserProp tr "Friction" eParam2.text
				setUserProp tr "SoundDist" eParam3.text
				setUserProp tr "Quality" eParam4.text
				setUserProp tr "DamageFlag" eParam5.text
				case rbEnvironment.state of
				(
					1:
					(
				    	setUserProp tr "Environment" "Flat"
				   	)
					2:
					(
				    	setUserProp tr "Environment" "Bank"
				   	)
					3:
				   	(
				    	setUserProp tr "Environment" "Bridge"
				   	)
				  	4:
				   	(
				    	setUserProp tr "Environment" "Mountains"
				   	)
				  	5:
				   	(
				    	setUserProp tr "Environment" "Canyon"
				   	)
				  	6:
				   	(
				    	setUserProp tr "Environment" "Tunnel"
				   	)
				)				
				setUserProp tr "Visibility" eParam7.text
				setUserProp tr "Tex1" eParam8.text
				setUserProp tr "TexLength" eParam9.text
				setUserProp tr "Tex2" "none"
				setUserProp tr "TexPar1" "0.2" 
				setUserProp tr "TexPar2" "0.5"
				setUserProp tr "TexPar3" "1.1"
--				setUserProp tr "Event0" ""
--				setUserProp tr "Event1" ""
--				setUserProp tr "Event2" ""
				if (spnVelocity.value>=0) then
				(
					setUserProp tr "Velocity" (spnVelocity.value as string)
				)
				tr.wireColor= (color 8 8 136)
				fixLength()
	)
--addproptotrack
	fn AddPropToSwitch radius1 radius2=
	(
		setUserProp tr "Type" "switch"
		setUserProp tr "Length" (spnLength.value as string)
		setUserProp tr "Roll1" "0.1"
		setUserProp tr "Roll2" "-0.1"
		setUserProp tr "Radius1" (radius1 as string)
		setUserProp tr "Radius2" (radius2 as string)
		setUserProp tr "MaxDist" eMaxdist.text
		setUserProp tr "MinDist" eMindist.text
		setUserProp tr "TrackWidth" eParam1.text
		setUserProp tr "Friction" eParam2.text
		setUserProp tr "SoundDist" eParam3.text
		setUserProp tr "Quality" eParam4.text
		setUserProp tr "DamageFlag" eParam5.text
		case rbEnvironment.state of
		(
			1:
			(
		    	setUserProp tr "Environment" "Flat"
		   	)
			2:
			(
		    	setUserProp tr "Environment" "Bank"
		   	)
			3:
		   	(
		    	setUserProp tr "Environment" "Bridge"
		   	)
		  	4:
		   	(
		    	setUserProp tr "Environment" "Mountains"
		   	)
		  	5:
		   	(
		    	setUserProp tr "Environment" "Canyon"
		   	)
		  	6:
		   	(
		    	setUserProp tr "Environment" "Tunnel"
		   	)
		)				
		setUserProp tr "Visibility" eParam7.text
		setUserProp tr "Tex1" eParam8.text
		setUserProp tr "TexLength" eParam9.text
		setUserProp tr "Tex2" eParam10.text
		setUserProp tr "TexPar1" eParam11.text
		setUserProp tr "TexPar2" eParam12.text
		setUserProp tr "TexPar3" eParam13.text
		if (spnVelocity.value>=0) then
		(
			setUserProp tr "Velocity" (spnVelocity.value as string)
		)
		tr.wireColor= (color 87 224 87)	
	)
-- addproptoswitch
	
	fn AddNewSwitch minPt minDir type1 type2 nodeName length direction1 direction2 radius1 radius2=
	(
		t1= (AddNewTrack minPt minDir type1 1 (nodeName) length direction1 radius1 0 0 #undefined)
		t2= (AddNewTrack minPt minDir type2 1 (nodeName) length direction2 radius2 0 0 #undefined)
		addAndWeld t1 t2 -1
		return t1
	)
-- addnewswitch
	fn GetPointOfTrack track noOfPoint=
	(		
		local Pt1,Dir1,noOfShape,noOfKnots
		minPt= [0,0,0.2]
		minDir= [0,1,0]
		convertToSplineShape track
		noOfKnots = numKnots track 1
		if (noOfPoint > noOfKnots) then
		(
			noOfShape = 2
			noOfPoint = noOfPoint - noOfKnots
		)
		else 
			noOfShape = 1
		minPt= getKnotPoint track noOfShape noOfPoint
		if ((getSegmentType track 1 1)==#line) then
			minDir= minPt - (getKnotPoint track 1 1)
		else
			minDir= minPt - (getInVec track noOfShape noOfPoint)							
		minDir= (normalize minDir)
		local pt
		pt= #()
		pt[1] = minPt
		pt[2] = minDir
		return pt
	)
--getpointoftrack
	tool CreateTrack
	( 
		local a,r,r2,t1,t2,ptArr
		local nodeName
		on mousePoint clickno do 
			if clickno == 1 then
			(
				nodeName = AddUniqueName()
				
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
				if (rbType.state==2 and spnRadius1.value==spnRadius2.value) then
               	(
--					rozjazd symetryczny
					tr = (AddNewSwitch ptArr[1] ptArr[2] 2 2 (nodeName) spnLength.value 1 2 spnRadius1.value spnRadius2.value)
--					t1= (AddNewTrack ptArr[1] ptArr[2] 2 1 (nodeName) spnLength.value 1 spnRadius1.value 0 0 #undefined)
--					t2= (AddNewTrack ptArr[1] ptArr[2] 2 1 (nodeName) spnLength.value 2 spnRadius2.value 0 0 #undefined)
					r= spnRadius1.value;
					r2= -spnRadius2.value
				) 
				else
				(
					if (rbDirection.state==1) then
       	            (
						tr = (AddNewSwitch ptArr[1] ptArr[2] rbType.state 2 (nodeName) spnLength.value rbDirection.state rbDirection.state spnRadius1.value spnRadius2.value)
--						t1= (AddNewTrack ptArr[1] ptArr[2] rbType.state 1 (nodeName) spnLength.value rbDirection.state spnRadius1.value 0 0 #undefined)
--						t2= (AddNewTrack ptArr[1] ptArr[2] 2 1 (nodeName) spnLength.value rbDirection.state spnRadius2.value 0 0 #undefined)
						if rbType.state==1 then
							r= 0
						else
					 		r= spnRadius1.value
						r2= spnRadius2.value
				   	)			  
				   	else
			    	(
						tr = (AddNewSwitch ptArr[1] ptArr[2] rbType.state 2 (nodeName) spnLength.value rbDirection.state rbDirection.state spnRadius1.value spnRadius2.value)
--						t1= (AddNewTrack ptArr[1] ptArr[2] rbType.state 1 (nodeName) spnLength.value rbDirection.state spnRadius1.value 0 0 #undefined)
--						t2= (AddNewTrack ptArr[1] ptArr[2] 2 1 (nodeName) spnLength.value rbDirection.state spnRadius2.value 0 0 #undefined)
						if rbType.state==1 then
							r= 0
						else
					 		r= -spnRadius1.value
						r2= -spnRadius2.value
				    )
				)/**/
--				addAndWeld t1 t2 -1
--				tr= t1
				AddPropToSwitch r r2
-- 				.inc dla zwrotnicy
				str="include;"+eFileName.text+";%;%;%;%;%;"+eTexture.text+";end"
				setUserProp tr "ExportString" str

				#stop 
			)
	)
 
	tool CreateCrossSwitch
	(
 		on mousePoint clickno do 
		(
			nodeName = AddUniqueName()
			if clickno == 1 then
			(
				print "Wstawianie rozjazdu krzyzowego"
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
				kat = atan (ptArr[2][1]/ptArr[2][2])
				if (rbDirection.state == 2) then
					kat = kat+6.49345
				anglDir= (getDir #scripts)+"\\EU07\\A\\"	-- wstawiamy plik
			    MergeMaxFile (anglDir+"Anglik02.max") #mergeDups
				rotate $Anglik (eulerangles 0 0 -kat)	--obracamy o zadany kat zaleznie od tego czy w prawo czy w lewo
				if (rbDirection.state == 2) then	--dostawiamy rozjazd zaleznie od tego do ktorej strony prostej
				(
					if (ptArr[2][2] < 0) then
						anglikPos = getKnotPoint $anglik_cc 1 2
					else if (ptArr[2][2] > 0) then
						anglikPos = getKnotPoint $anglik_aa 1 2
				)
				else
				(
					if (ptArr[2][2] < 0) then
						anglikPos = getKnotPoint $anglik_dd 1 2
					else if (ptArr[2][2] > 0) then
						anglikPos = getKnotPoint $anglik_bb 1 2
				)
				przesuniecie = ptArr[1] - anglikPos	--obliczanie przesuniecie do wybranej czeci rozjazdu
				$Anglik.pos = $Anglik.pos + przesuniecie --przesuwamy rozjazd na wybrana pozycje
				
				$anglik_test02.name=nodeName	--zmieniamy nazwy 
				$anglik_a.name=(nodeName+"_a")
				$anglik_b.name=(nodeName+"_b")
				$anglik_c.name=(nodeName+"_c")
				$anglik_d.name=(nodeName+"_d")
			    $anglik_test02_pods.name=(nodeName+"_pods")
				$anglik_aa.name=(nodeName+"_aa")
				$anglik_bb.name=(nodeName+"_bb")
				$anglik_cc.name=(nodeName+"_cc")
				$anglik_dd.name=(nodeName+"_dd")
				$anglik_ac.name=(nodeName+"_ac")
				$anglik_ad.name=(nodeName+"_ad")
				$anglik_bc.name=(nodeName+"_bc")
				$anglik_bd.name=(nodeName+"_bd")
			    $Anglik.name=nodeName /**/
				#stop
			)
		)
	)

	tool CreateCrossSwitchWithStrew
	(
 		on mousePoint clickno do 
		(
			nodeName = AddUniqueName()
			if clickno == 1 then
			(
				print "Wstawianie rozjazdu krzyzowego z podsypka"
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
				kat = (atan (ptArr[2][1]/ptArr[2][2]))-90
				if (rbDirection.state == 2) then
					kat = kat+6.49345
				anglDir= (getDir #scripts)+"\\EU07\\A\\"	-- wstawiamy plik
			    MergeMaxFile (anglDir+"rkpd.max") #mergeDups
				if (StrewParam.text == "TpD1") then
				(
					$Anglik_TpD1.name = "Anglik"
					$rkpd_TpD1.name = "rkpd_inc"
					$naped_1.name = "naped_ab"
					$naped_2.name = "naped_cd"
					--wywalamy co niepotrzebne
					delete $Anglik_TpD2
					delete $Anglik_TpD_oil2
				)
				else if (StrewParam.text == "TpD2") then
				(
					$Anglik_TpD2.name = "Anglik"
					$rura02.name = "rura"
					$rkpd_TpD2.name = "rkpd_inc"
					$naped_06.name = "naped_ab"
					$naped_05.name = "naped_cd"
					--wywalamy co niepotrzebne
					delete $Anglik_TpD1
					delete $Anglik_TpD_oil2
				)
				else if (StrewParam.text == "TpD-oil2") then
				(
					$Anglik_TpD_oil2.name = "Anglik"
					$rura01.name = "rura"
					$rkpd_TpD_oil2.name = "rkpd_inc"
					$naped_04.name = "naped_ab"
					$naped_03.name = "naped_cd"
					--wywalamy co niepotrzebne
					delete $Anglik_TpD1
					delete $Anglik_TpD2
				)
				rotate $Anglik (eulerangles 0 0 -kat)	--obracamy o zadany kat zaleznie od tego czy w prawo czy w lewo
				if (rbDirection.state == 2) then	--dostawiamy rozjazd zaleznie od tego do ktorej strony prostej
				(
					if (ptArr[2][2] < 0) then
						anglikPos = getKnotPoint $anglik_cc 1 1
					else if (ptArr[2][2] > 0) then
						anglikPos = getKnotPoint $anglik_aa 1 1
				)
				else
				(
					if (ptArr[2][2] < 0) then
						anglikPos = getKnotPoint $anglik_dd 1 1
					else if (ptArr[2][2] > 0) then
						anglikPos = getKnotPoint $anglik_bb 1 1
				)
				przesuniecie = ptArr[1] - anglikPos	--obliczanie przesuniecie do wybranej czeci rozjazdu
				$Anglik.pos = $Anglik.pos + przesuniecie --przesuwamy rozjazd na wybrana pozycje
				
				$rkpd_inc.name=nodeName	--zmieniamy nazwy 
				$anglik_a.name=(nodeName+"_a")
				$anglik_b.name=(nodeName+"_b")
				$anglik_c.name=(nodeName+"_c")
				$anglik_d.name=(nodeName+"_d")
			    $pods_rkpd.name=(nodeName+"_pods")
				$anglik_aa.name=(nodeName+"_aa")
				$anglik_bb.name=(nodeName+"_bb")
				$anglik_cc.name=(nodeName+"_cc")
				$anglik_dd.name=(nodeName+"_dd")
				$anglik_ac.name=(nodeName+"_ac")
				$anglik_ad.name=(nodeName+"_ad")
				$anglik_bc.name=(nodeName+"_bc")
				$anglik_bd.name=(nodeName+"_bd")
				$rura.name=(nodename+"_rura")
				$naped_ab.name=(nodeName+"_naped_ab")
				$naped_cd.name=(nodeName+"_naped_cd")
			    $Anglik.name=nodeName /**/
				#stop
			)
		)
	)

	on rbDirection changed state do
	(
		case state of
		(
			1: 
			(
				eFileName.text= "ZwrL34R300.inc"
			)
			2:
			(
				eFileName.text= "ZwrP34R300.inc"
			)
		)
	)

	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnRadius1.enabled= false
			)
			2:
			(
				spnRadius1.enabled= true
			)
		)
	)

	on btn1 pressed do
	(
		startTool CreateTrack
	)
	on eStationName changed text do
	        eName.text= eStationName.text+"_zwr"+eSwitchNumber.text
	on eSwitchNumber changed text do
	        eName.text= eStationName.text+"_zwr"+eSwitchNumber.text
--	obsLuga buttonow do zwrotnic	
--  25R190
	on zBt1 pressed do
	(
		spnRadius2.value = 190
		spnLength.value = 25
		rbType.state = 1
		rbDirection.state = 1
		eFileName.text = "zwrl25r190.inc"
		eTexture.text = "zwrl25r190"
		startTool CreateTrack
	)
	on zBt2 pressed do
	(
		spnRadius2.value = 190
		spnLength.value = 25
		rbType.state = 1
		rbDirection.state = 2
		eFileName.text = "zwrp25r190.inc"
		eTexture.text = "zwrp25r190"
		startTool CreateTrack
	)
--	34R300	
	on zBt3 pressed do
	(
		spnRadius2.value = 300
		spnLength.value = 34
		rbType.state = 1
		rbDirection.state = 1
		eFileName.text = "zwrl34r300aut.inc"
		eTexture.text = "zwrot34r300pods-new"
		startTool CreateTrack
	)
	on zBt4 pressed do
	(
		spnRadius2.value = 300
		spnLength.value = 34
		rbType.state = 1
		rbDirection.state = 2
		eFileName.text = "zwrp34r300aut.inc"
		eTexture.text = "zwrot34r300pods-new"
		startTool CreateTrack
	)
--	65R1200
	on zBt5 pressed do
	(
		spnRadius2.value = 1200
		spnLength.value = 65
		rbType.state = 1
		rbDirection.state = 1
		eFileName.text = "zwrl65r1200.inc"
		eTexture.text = "zwrotl65r1200pods-new"
		startTool CreateTrack
	)
	on zBt6 pressed do
	(
		spnRadius2.value = 1200
		spnLength.value = 65
		rbType.state = 1
		rbDirection.state = 2
		eFileName.text = "zwrp65r1200.inc"
		eTexture.text = "zwrotp65r1200pods-new"
		startTool CreateTrack
	)
--	Y32R300
	on zBt7 pressed do
	(
		spnRadius1.value = 300
		spnRadius2.value = 300
		spnLength.value = 34
		rbType.state = 2
		eFileName.text = "zwry34r300.inc"
		eTexture.text = "zwroty34r300pods"
		startTool CreateTrack
	)
	

	

--	K34R150
	on zBt8 pressed do
	(
		startTool CreateCrossSwitch
	)
--	K34R190
	on zBt9 pressed do
	(
		startTool CreateCrossSwitchWithStrew
	)

)
