
-- Updated by Michh_EU

	global ostream, tabs = ""
	global isFileSCM  = false
	
		------------------------------------------------------------------------------------------------	
	rollout SCMTerExport "Terrain Exporter" 
	(
		Group "Options" 
		(
		 checkbox cb_exportSelOnly "Export Selected Only"  
		 checkbox cb_Rozszezenia "Dodaj rozszezenia plikow tekstur"	
		)
		button btn_export "Export scenery..."  
       		
	
		
		function DodajRozszezenie tex1=
		(
		if cb_Rozszezenia.checked==false then
			(
			pos1 = findString tex1 ".dds"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
				
			pos1 = findString tex1 ".tga"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
				
			pos1 = findString tex1 ".bmp"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
			
			)
		else return tex1
		
		)
		-------------------------------------------------------------------------------------
		function ExportMesh meshObj =
		(
		
			varname= meshObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
			 
			bHasMap= false;
			texture= "none";
			--part = 0
			if (meshObj.material!=undefined) then
			(
				if ((meshObj.material.mapEnables[2]) and (meshObj.material.maps[2]!=undefined)) then
				(
					--pobieramy ca ciek cznie z kocow nazw pliku
					local path = (getFilenamePath meshObj.material.maps[2].filename) + (filenameFromPath meshObj.material.maps[2].filename)
					print (Format ("Sciezka textury: % ") path)
					local filtr = "\\"
					--filtrujemy przez / aby uzyska poszczeglne skadniki
					local t = (filterString path filtr)
					local jestFolder = false
					--sprawdzamy kolei wszystkie wartoci w tablicy szukajc wartoci extures (t cina podczas filtrowania)
					for i=1 to t.count do
					(
						if jestFolder == false then
						(
							--jeli jeszcze nie doszed do tego pola to nic nie zapisujemy
							--jesli doszed to dajemy, e od tej pory reszt pl bdzie zapisywa
							if (findString t[i] "extures") != undefined then
							(
								jestFolder = true
								texture = ""
							)
							else
							(
								texture = t[i]
							)
						)
						else
						(
							--zapisujemy wartoc do cieki
							texture = texture + t[i]
							--jeli pole nie jest ostatnie to dodajemy \
							if i < t.count then
								texture = texture + "\\"
						)
					)
					texture = DodajRozszezenie texture
					bHasMap= true;
					print (Format ("Rozbicie: % Tekstura: % ") t texture)
				)
				
			)
			else
			(
--				Format ("Diffuse: % % %\n") meshObj.wireColor.r meshObj.wireColor.b meshObj.wireColor.g to:ostream
--				Format ("Map: none\n") to:ostream
			)				
			update meshObj true true true
			
			if (meshObj.numFaces) > 0 then
			(
				if (bHasMap==true) then
				(
					for i = 1 to (meshObj.numFaces) do
					(
						
						vrt= (GetVert meshObj (GetFace meshObj i).x )
						vrt2= (GetVert meshObj (GetFace meshObj i).y )
						vrt3= (GetVert meshObj (GetFace meshObj i).z )
					
--						(Format "% % % \n" vrt vrt2 vrt3)
						if (vrt!=vrt2 and vrt!=vrt3 and vrt2!=vrt3) then
						(
							maxdist= (getUserProp meshObj "MaxDistance")
							if (maxdist==undefined) then
								maxdist= -1                       
							mindist= (getUserProp meshObj "MinDistance")
							if (mindist==undefined) then
								mindist= 0	
							
							--if (i==1 or part == 300) then
							--(
							Format ("node % % none triangles") maxdist mindist to:ostream
							Format (" %\n") texture to:ostream

							--)
							--if (part >= 300) then
							--(part = 0)
							
--							tu= (GetTVert meshObj (GetTVFace meshObj i).x ).x;
--							tv= (GetTVert meshObj (GetTVFace meshObj i).x ).y;
							
							Format ("% ") (-vrt.x) to:ostream
							Format ("% ") (vrt.z)  to:ostream
							Format ("% ") (vrt.y)  to:ostream
							norm= getNormal meshObj (GetFace meshObj i).x
							Format ("% ") (-norm.x) to:ostream
							Format ("% ") (norm.z)  to:ostream
							Format ("% ") (norm.y)  to:ostream
--							Format ("0.0 ")  to:ostream
--							Format ("0.0 ")  to:ostream
							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).x ).x) to:ostream
							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).x ).y) to:ostream
							Format ("end\n") to:ostream
					
							vrt= vrt2
							Format ("% ") (-vrt.x) to:ostream
							Format ("% ") (vrt.z) to:ostream
							Format ("% ") (vrt.y) to:ostream
							norm= getNormal meshObj (GetFace meshObj i).y
							Format ("% ") (-norm.x) to:ostream
							Format ("% ") (norm.z) to:ostream
							Format ("% ") (norm.y) to:ostream
--							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).x-tu) to:ostream
--							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).y-tv) to:ostream
							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).x) to:ostream
							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).y) to:ostream
							Format ("end\n") to:ostream
							
							vrt= vrt3
							Format ("% ") (-vrt.x) to:ostream
							Format ("% ") (vrt.z) to:ostream
							Format ("% ") (vrt.y) to:ostream
							norm= getNormal meshObj (GetFace meshObj i).z
							Format ("% ") (-norm.x) to:ostream
							Format ("% ") (norm.z) to:ostream
							Format ("% ") (norm.y) to:ostream
--							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).x-tu) to:ostream
--							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).y-tv) to:ostream
							Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).x) to:ostream
							
							--if(i == meshObj.numFaces or part >= 297 ) then
							--(
							Format ("% \n") ((GetTVert meshObj (GetTVFace meshObj i).z ).y) to:ostream
							Format ("endtri\n") to:ostream
							--Format ("\n") to:ostream
							--)
							--else
							--(
							--Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).y) to:ostream
							--Format ("end\n") to:ostream
							--)
							--part = part + 3

						)
						else
							(Format "Degenerated triangle!")
					)	
				)
			)
			
		)	

		-------------------------------------------------------------------------------------
		function ExportNode1 node =
		(
			if ((getUserProp node "ExportLast")!=true) then
			(
				Format ("Node: % % %\n") (superClassOf node) (classOf node) node.name
				if (SuperClassOf node == GeometryClass) then
				(
					convertToMesh node
					if (ClassOf node == Editable_mesh) then
						ExportMesh node
				)
			)

				return true
		)
	
		-------------------------------------------------------------------------------------
		function ExportNode2 node =
		(
			if ((getUserProp node "ExportLast")==true) then
			(
				Format ("Node: % % %\n") (superClassOf node) (classOf node) node.name
				if (SuperClassOf node == GeometryClass) then
				(
					convertToMesh node
					if (ClassOf node == Editable_mesh) then
						ExportMesh node
				)
			)
	
			return true
		)
		
		-------------------------------------------------------------------------------------
		function RecursiveExportNode1 node =
		(
			if (ExportNode1 node) == false then
				return false
			for child in node.children do
				RecursiveExportNode1 child
		)
	
		-------------------------------------------------------------------------------------
		function RecursiveExportNode2 node =
		(
			if (ExportNode2 node) == false then
				return false
			for child in node.children do
				RecursiveExportNode2 child
		)
	
		-------------------------------------------------------------------------------------
		function ExportSCM =
		(					
				for node in selection do
					ExportNode1 node
				for node in selection do
					ExportNode2 node
			Print "Done";
		)
		-------------------------------------------------------------------------------------
		function GetSaveFileStream =
		(
			MessageBox "Wprowadz nazwe samej komorki"
			fname = GetSaveFileName types:"SCM Files (*_ter.scm)|*_ter.scm|All Files(*.*)|*.*|"
			if fname == undefined then
				return undefined

			if getFilenameType(fname) == "_ter.scm" then
				isFileSCM = true
			fname = fname + "_ter.scm"
			ostream = CreateFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for writing !"


				return undefined
			)
	
			return ostream
		)	
		-------------------------------------------------------------------------------------      	
	    on btn_export pressed do
		(
			ostream = GetSaveFileStream()
			if ostream != undefined then
			(
				ExportSCM()
				Close ostream
			)			
		)
	
)