-------------------------------------------------------------------------------------
-- T3DExport.ms
-- update 17.07.2011
-------------------------------------------------------------------------------------

	fileIn (scriptDirectory+"Reset_Xform.ms")
	rollout T3DExport "T3d Exporter"
	(
		local ostream, tabs = ""
	
		group "Options"
		(
			checkbox cb_exportSelOnly "Eksportuj tylko zaznaczone obiekty"
			checkbox cb_Rozszezenia "Dodaj rozszezenia plikow tekstur"
--          editText eTexturePath "Texture path:" text:"ip/szczecin/" 
		)
	
		button btn_export "Save As..." width:100
	
		global sc
	
		function DodajRozszezenie tex1=
		(
		if cb_Rozszezenia.checked==false then
			(
			pos1 = findString tex1 ".dds"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
				
			pos1 = findString tex1 ".tga"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
				
			pos1 = findString tex1 ".bmp"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
			
			)
		else return tex1
		
		)
	
		-------------------------------------------------------------------------------------
		function ExportMesh meshObj =
		(
		
			
			
			Format ("\n") to:ostream
			Format ("//---------------------------------------------------------------------------------") to:ostream
			Format ("\n") to:ostream
			
--			convertToMesh meshObj
--			resetXFormU meshObj
--			collapseStack meshObj
	
			if (meshObj.parent!=undefined) then
			(
				varname= meshObj.parent.name
				for i = 1 to varname.count do
					if varname[i] == " " then varname[i] = "_"
				Format ("Parent: %\n") varname to:ostream
			)
			else
				Format ("Parent: none\n") to:ostream

			Format ("Type: Mesh\n") varname to:ostream
			
			varname= meshObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
			Format ("Name: %\n") varname to:ostream

			prop= (getUserProp meshObj "Anim")
			if prop == undefined then prop= (getUserProp meshObj "anim")
			if (prop!=undefined) then
				Format ("Anim: % \n") prop to:ostream
			else
				Format ("Anim: false \n") varname to:ostream
			
			bHasMap= false;
			if (meshObj.material!=undefined) then
			(
			
				Format ("Ambient: % % %\n") meshObj.material.ambient.r meshObj.material.ambient.g meshObj.material.ambient.b to:ostream
				Format ("Diffuse: % % %\n") meshObj.material.diffuse.r meshObj.material.diffuse.g meshObj.material.diffuse.b to:ostream
				Format ("Specular: % % %\n") meshObj.material.specular.r meshObj.material.specular.g meshObj.material.specular.b to:ostream
				if (meshObj.material.selfIllumAmount) == 100 then selfIll = "true"
				else if (meshObj.material.selfIllumAmount) == 0 then selfIll = "false"
				else selfIll = ((meshObj.material.selfIllumAmount) as string)

				
				Format ("SelfIllum: %\n") selfIll to:ostream
				Format ("Wire: %\n") meshObj.material.wire to:ostream
				Format ("WireSize: %\n") meshObj.material.wireSize to:ostream
				Format ("Opacity: %\n") meshObj.material.opacity to:ostream
				

				if ((meshObj.material.mapEnables[2]) and (meshObj.material.maps[2]!=undefined)) then
				(

					--pobieramy cala ciezke lacznie z koncowa nazwa pliku
					local path = (getFilenamePath meshObj.material.maps[2].filename) + (filenameFromPath meshObj.material.maps[2].filename)
					TypModelu = "none"
							
					--************************************************************************************************************************
					--Poprawiono ISDR
					ftext = "extures\\"
					
					
					--sprawdzanie typu Modelu, Gdzie znajnuje siemodel
					--zwykly model
					sciezka = "undefined"
					pos1 = (FindString path ftext)

					if ((pos1 as string)  != "undefined") then 
							(
							sciezka = SubString path (pos1 + ftext.count) -1 
							)

					--ciezka do modelu
					sciezkaM = "undefined"
					ftext = "odels\\"
					posSC1 =  FindString sc ftext

					if((posSC1 as string) != "undefined") then	sciezkaM  = SubString sc (posSC1 + ftext.count) -1
										
					
					--sprawdzanie  w ciezce do modelu jest jeszcze jaki katalog
					posSC2 = FindString sciezkaM "\\"		
	
					pos2 =  FindString sciezka "\\"

					if((pos2 as string) == "undefined" and (posSC2 as string) != "undefined" ) then
							(
							sciezka = "/"+sciezka	
							
							)
					
					--Sprawdzenie czy to jest w katalogu dynamic	
					ftext = "ynamic"
					posDyn = FindString path ftext

					if((posDyn as string) != "undefined") then 
							(							
							sciezka = filenameFromPath meshObj.material.maps[2].filename
							)
							
					if (sciezka as string) == "undefined" then sciezka = filenameFromPath meshObj.material.maps[2].filename
					--****************************************************************************************************************

					for j=1 to sciezka.count do
					(
					if sciezka[j] == "\\" then sciezka[j] = "/"
					)
					
					--Tu usunac rozszezenie
					sciezka = DodajRozszezenie sciezka
					
					Format ("Map: %\n") (sciezka) to:ostream
					bHasMap= true;
				)
				else
				(
					Format ("Map: none\n") to:ostream
				)
				
			)
			else
			(
				Format ("Ambient: % % %\n") meshObj.wireColor.r meshObj.wireColor.g meshObj.wireColor.b to:ostream
				Format ("Diffuse: % % %\n") meshObj.wireColor.r meshObj.wireColor.g meshObj.wireColor.b to:ostream
				Format ("Specular: 0 0 0\n") to:ostream
				Format ("SelfIllum: false\n") to:ostream
				Format ("Wire: false\n") to:ostream
				Format ("WireSize: 0\n") to:ostream
				Format ("Opacity: 100\n") to:ostream
				Format ("Map: none\n") to:ostream
			)
			
			prop= (getUserProp meshObj "MaxDistance")
			if (prop!=undefined) then
				Format ("MaxDistance: % \n") prop to:ostream
			else
				Format ("MaxDistance: 1000\n") to:ostream

			prop= (getUserProp meshObj "MinDistance")
			if (prop!=undefined) then
				Format ("MinDistance: % \n") prop to:ostream
			else
				Format ("MinDistance: 0\n") to:ostream
			
			if (meshObj.parent!=undefined) then
				TM= meshObj.transform * (inverse meshObj.parent.transform)
			else
				TM= meshObj.transform
			
			Format ("Transform: \n") to:ostream 
			Format ("           % % % 0.0\n") TM.row1.x TM.row1.y TM.row1.z to:ostream
			Format ("           % % % 0.0\n") TM.row2.x TM.row2.y TM.row2.z to:ostream
			Format ("           % % % 0.0\n") TM.row3.x TM.row3.y TM.row3.z to:ostream
			Format ("           % % % 1.0\n") TM.row4.x TM.row4.y TM.row4.z to:ostream
			
			Format ("NumVerts: % \n") (meshObj.numFaces*3) to:ostream

			update meshObj true true true
			if (meshObj.numFaces) > 0 then
			(
				if (bHasMap==true) then
				(
				for i = 1 to (meshObj.numFaces) do
				(
					
					Format ("% \n") (getFaceSmoothGroup meshObj i) to:ostream

					vrt= (GetVert meshObj (GetFace meshObj i).x )*(inverse meshObj.transform)
					Format ("% ") (vrt.x) to:ostream
					Format ("% ") (vrt.y) to:ostream
					Format ("% 	") (vrt.z) to:ostream
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).x ).x) to:ostream
					Format ("% \n") ((GetTVert meshObj (GetTVFace meshObj i).x ).y) to:ostream
					
					vrt= (GetVert meshObj (GetFace meshObj i).y )*(inverse meshObj.transform)
					Format ("% ") (vrt.x) to:ostream
					Format ("% ") (vrt.y) to:ostream
					Format ("% 	") (vrt.z) to:ostream
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).x) to:ostream
					Format ("% \n") ((GetTVert meshObj (GetTVFace meshObj i).y ).y) to:ostream
					
					vrt= (GetVert meshObj (GetFace meshObj i).z )*(inverse meshObj.transform)
					Format ("% ") (vrt.x) to:ostream
					Format ("% ") (vrt.y) to:ostream
					Format ("% 	") (vrt.z) to:ostream
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).x) to:ostream
					Format ("% \n") ((GetTVert meshObj (GetTVFace meshObj i).z ).y) to:ostream
					Format ("\n") to:ostream
				)	
				)
				else
				(
				for i = 1 to (meshObj.numFaces) do
				(
					Format ("% \n") (getFaceSmoothGroup meshObj i) to:ostream

					vrt= (GetVert meshObj (GetFace meshObj i).x )*(inverse meshObj.transform)
					Format ("% ") (vrt.x) to:ostream
					Format ("% ") (vrt.y) to:ostream
					Format ("% 	") (vrt.z) to:ostream
					Format ("0 ") to:ostream
					Format ("0 \n") to:ostream
					
					vrt= (GetVert meshObj (GetFace meshObj i).y )*(inverse meshObj.transform)
					Format ("% ") (vrt.x) to:ostream
					Format ("% ") (vrt.y) to:ostream
					Format ("% 	") (vrt.z) to:ostream
					Format ("0 ") to:ostream
					Format ("0 \n") to:ostream
					
					vrt= (GetVert meshObj (GetFace meshObj i).z )*(inverse meshObj.transform)
					Format ("% ") (vrt.x) to:ostream
					Format ("% ") (vrt.y) to:ostream
					Format ("% 	") (vrt.z) to:ostream
					Format ("0 ") to:ostream
					Format ("0 \n") to:ostream
					Format ("\n") to:ostream
				)
				)	
			)
			
		)
	
		-------------------------------------------------------------------------------------
		function ExportPoint ptObj =
		(
			Format ("\n") to:ostream
			Format ("//---------------------------------------------------------------------------------") to:ostream
			Format ("\n") to:ostream

--			resetXFormU ptObj 
--			collapseStack ptObj 
			
			if (ptObj.parent!=undefined) then
			(
				varname= ptObj.parent.name
				for i = 1 to varname.count do
					if varname[i] == " " then varname[i] = "_"
				Format ("Parent: %\n") varname to:ostream
			)
			else
				Format ("Parent: none\n") to:ostream

			Format ("Type: Point\n") varname to:ostream
			
			varname= ptObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
			Format ("Name: %\n") varname to:ostream

			prop= (getUserProp ptObj "Anim")
			if (prop!=undefined) then
				Format ("Anim: % \n") prop to:ostream
			else
				Format ("Anim: false \n") varname to:ostream


				Format ("Diffuse: % % %\n") ptObj.wireColor.r ptObj.wireColor.g ptObj.wireColor.b to:ostream
				
				Format ("SelfIllum: true\n") to:ostream

			prop= (getUserProp ptObj "MaxDistance")
			if (prop!=undefined) then
				Format ("MaxDistance: % \n") prop to:ostream
			else
				Format ("MaxDistance: 1000\n") to:ostream

			prop= (getUserProp ptObj "MinDistance")
			if (prop!=undefined) then
				Format ("MinDistance: % \n") prop to:ostream
			else
				Format ("MinDistance: 0\n") to:ostream
			
			if (ptObj.parent!=undefined) then
				TM= ptObj.transform * (inverse ptObj.parent.transform)
			else
				TM= ptObj.transform
			
			Format ("Transform: \n") to:ostream 
			Format ("           % % % 0.0\n") TM.row1.x TM.row1.y TM.row1.z to:ostream
			Format ("           % % % 0.0\n") TM.row2.x TM.row2.y TM.row2.z to:ostream
			Format ("           % % % 0.0\n") TM.row3.x TM.row3.y TM.row3.z to:ostream
			Format ("           % % % 1.0\n") TM.row4.x TM.row4.y TM.row4.z to:ostream
			
		)
--McZapkie-050702:export stozka swiatla
		-------------------------------------------------------------------------------------
		function ExportFreeSpot fsObj =
		(
			Format ("\n") to:ostream
			Format ("//---------------------------------------------------------------------------------") to:ostream
			Format ("\n") to:ostream
			
			if (fsObj.parent!=undefined) then
			(
				varname= fsObj.parent.name
				for i = 1 to varname.count do
					if varname[i] == " " then varname[i] = "_"
				Format ("Parent: %\n") varname to:ostream
			)
			else
				Format ("Parent: none\n") to:ostream

			Format ("Type: FreeSpotLight\n") varname to:ostream
			
			varname= fsObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
			Format ("Name: %\n") varname to:ostream

			prop= (getUserProp fsObj "Anim")
			if (prop!=undefined) then
				Format ("Anim: % \n") prop to:ostream
			else
				Format ("Anim: false \n") varname to:ostream


				Format ("Diffuse: % % %\n") fsObj.rgb.r fsObj.rgb.g fsObj.rgb.b to:ostream
				
				Format ("SelfIllum: true\n") to:ostream

			varname= fsObj.nearAttenStart
			Format ("NearAttenStart: %\n") varname to:ostream
			varname= fsObj.nearAttenEnd
			Format ("NearAttenEnd: %\n") varname to:ostream
			varname= fsObj.useNearAtten
			Format ("UseNearAtten: %\n") varname to:ostream
			varname= fsObj.attenDecay
			Format ("FarAttenDecayType: %\n") varname to:ostream
			varname= fsObj.DecayRadius
			Format ("FarDecayRadius: %\n") varname to:ostream
			varname= fsObj.falloff
			Format ("FalloffAngle: %\n") varname to:ostream
			varname= fsObj.hotspot
			Format ("HotspotAngle: %\n") varname to:ostream              
              
			prop= (getUserProp fsObj "MaxDistance")
			if (prop!=undefined) then
				Format ("MaxDistance: % \n") prop to:ostream
			else
				Format ("MaxDistance: 1000\n") to:ostream

			prop= (getUserProp fsObj "MinDistance")
			if (prop!=undefined) then
				Format ("MinDistance: % \n") prop to:ostream
			else
				Format ("MinDistance: 0\n") to:ostream
			
			if (fsObj.parent!=undefined) then
				TM= fsObj.transform * (inverse fsObj.parent.transform)
			else
				TM= fsObj.transform
			
			Format ("Transform: \n") to:ostream 
			Format ("           % % % 0.0\n") TM.row1.x TM.row1.y TM.row1.z to:ostream
			Format ("           % % % 0.0\n") TM.row2.x TM.row2.y TM.row2.z to:ostream
			Format ("           % % % 0.0\n") TM.row3.x TM.row3.y TM.row3.z to:ostream
			Format ("           % % % 1.0\n") TM.row4.x TM.row4.y TM.row4.z to:ostream
			
		)


		
		-------------------------------------------------------------------------------------
		function ExportNode node =
		(
			if SuperClassOf node == GeometryClass and ClassOf node == Editable_mesh then
				ExportMesh node
			if SuperClassOf node == Helper and ClassOf node == Point then
				ExportPoint node
			if SuperClassOf node == Light and ClassOf node == FreeSpot  then
				ExportFreeSpot node

			return true
		)
	
		-------------------------------------------------------------------------------------
		function RecursiveExportNode node =
		(
			if (ExportNode node) == false then
				return false
	
			for child in node.children do
				RecursiveExportNode child
				
		)
	
		-------------------------------------------------------------------------------------
		function ExportT3D =
		(
			
			if cb_exportSelOnly.checked then
			(
				for node in selection do
					ExportNode node
			)
			else
			(
				for node in rootnode.children do
					RecursiveExportNode node
			)
		)
	
		-------------------------------------------------------------------------------------
		function GetSaveFileStream =
		(
			fname = GetSaveFileName types:"T3d Script Files (*.t3d)|*.t3d|All Files(*.*)|*.*|"
			if fname == undefined then
				return undefined
	
			
			sc = fname
			ostream = CreateFile fname
			
			
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for writing !"
				return undefined
			)
	
			return ostream
		)
	
	
		-------------------------------------------------------------------------------------
		on btn_export pressed do
		(

			ostream = GetSaveFileStream()
			if ostream != undefined then
			(
				ExportT3D()
				Close ostream
			)
		)
	
	) -- End T3DExport
	