-- MS
--	
--
-- Author :   Marcin Woniak
-- Version:  3ds max 4
--
-- Updated by Speed
--  14-04-2004
-- Updated by Michh_EU
--  04-09-2004
-- Updated by pol102
--  05-07-2007
-- Updated by firleju
--  19-09-2007
-- Updated by ISDR
-- 	27-06-2010


-- create the rollout window and add the  rollout
if MainFloater != undefined do
(
	closerolloutfloater MainFloater
)
MainFloater = newRolloutFloater "Edytor scenerii" 350 600
rollout ustawienia "Ustawienia Skryptu"
(
	edittext eDi "Sciezka do symulatora MaSzyna Eu07" text:"C:\\"
	button wybierz "wybierz katalog"
 	button butok "Zapisz"
 
 	fn save=
 	(
		scriptDirectory= (getDir #scripts)+"\\EU07\\"
		setINISetting (scriptDirectory+"ustawienia.ini") "ustawienia_glowne" "DirEu" eDi.text

		setINISetting (scriptDirectory+"ustawienia.ini") "ustawienia_glowne" "DirCHK" (eDi.text+"\dynamic\\PKP\\EU07\\"+"*.chk")

 	)
 	
	on butok pressed do
 	(
  		save()
  		removeRollout ustawienia MainFloater
 	)
 
 	on wybierz pressed do
 	(
		
		eDi.text = (getSavePath caption:"wybierz katalog symulatora MaSzyna Eu07")
 	)
 
 
 	fn asd = 
 	(
		scriptDirectory= (getDir #scripts)+"\\EU07\\"
		SCI = getINISetting (scriptDirectory+"ustawienia.ini" ) "ustawienia_glowne" "DirEu"
		if SCI != undefined then eDi.text = SCI
		
 	)
 	
	on ustawienia open do
 	(
  		asd()
 	)
	



) 
		
fn getFile=
(
	fileopen=(scriptDirectory+"ustawienia.skryptu")
	ver= doesFileExist fileopen
	if ver==true then
	(
		closerolloutfloater rees
		a-ddRollout Main MainFloater
	)
	if ver==false then
	(
		k()
	)
)

fn k=
(
	ostreamed = CreateFile "ustawienia.skryptu"
--	format (" %\n") ePatch.text to:ostreamed
	close ostreamed
--	closerolloutfloater rees
)

rollout progress "Trwa ladowanie skryptu" 
(
	progressBar prog value:0 color:red
) 
createDialog progress 200 30 bgcolor:blue

scriptDirectory= (getDir #scripts)+"\\EU07\\"
scnImportDir= (getDir #scripts)+"\\EU07\\"


fileIn (scriptDirectory+"CreateIncRandomTree.ms")
fileIn (scriptDirectory+"CreateDynamic.ms")
progress.prog.value = 5
fileIn (scriptDirectory+"CreateTrainSet.ms")
progress.prog.value = 10
fileIn (scriptDirectory+"CreateTrack.ms")
fileIn (scriptDirectory+"CreateStrew.ms")
progress.prog.value = 15
fileIn (scriptDirectory+"CreateRoad.ms")
progress.prog.value = 20
fileIn (scriptDirectory+"CreateRiver.ms")
progress.prog.value = 25
fileIn (scriptDirectory+"CreateModel.ms")
progress.prog.value = 30
fileIn (scriptDirectory+"CreateIncTree.ms")
progress.prog.value = 35
fileIn (scriptDirectory+"CreateEventSwitch.ms")
progress.prog.value = 40
fileIn (scriptDirectory+"CreateSignal.ms")
progress.prog.value = 45
fileIn (scriptDirectory+"CreateSound.ms")
progress.prog.value = 50
progress.prog.color = yellow
fileIn (scriptDirectory+"CreateIncActive.ms")
fileIn (scriptDirectory+"CreateLine.ms")
progress.prog.value = 55
fileIn (scriptDirectory+"CreateCustom.ms")
progress.prog.value = 60
fileIn (scriptDirectory+"CreateEventLights.ms")
fileIn (scriptDirectory+"CreateEventMultiple.ms")
progress.prog.value = 65
fileIn (scriptDirectory+"CreateEventTrackVel.ms")
fileIn (scriptDirectory+"CreateEventAngSwitch.ms")
progress.prog.value = 70
fileIn (scriptDirectory+"ScnExp.ms")
fileIn (scriptDirectory+"ScmExp.ms")
fileIn (scriptDirectory+"ScmTerExp.ms")
fileIn (scriptDirectory+"CheckNullTrack.ms")
progress.prog.value = 75
fileIn (scriptDirectory+"T3dExp.ms")
--fileIn (scriptDirectory+"B3dExp.ms")
fileIn (scriptDirectory+"EvExp.ms")
progress.prog.value = 80
fileIn (scriptDirectory+"DelanuayExp.ms")
fileIn (scriptDirectory+"CreateTraction.ms")
progress.prog.value = 85
fileIn (scriptDirectory+"CreateGantryInc.ms")
fileIn (scriptDirectory+"3dExp.ms")
progress.prog.value = 90
progress.prog.color = green
fileIn (scriptDirectory+"CreatePowerInc.ms")
fileIn (scnImportDir+"scnImport.ms")
progress.prog.value = 95
fileIn (scriptDirectory+"WstawRozkrz.ms")
fileIn (scriptDirectory+"CreateHekto.ms")
fileIn (scriptDirectory+"CreatePointers.ms")
progress.prog.value = 100
DestroyDialog progress

rollout Main "Glowne narzedzia developera"
(
		group "Trasa"
		(
			button bTrack "Tory" width:70 height:16 across:2
			button bSwitch "Zwrotnice" width:70 height:16
			button bRoad "Drogi" width:70 height:16 across:2
			button bRiver "Rzeka" width:70 height:16 enabled:true
--			button brozkrz "Rozjazd Krzyzowy" width:120 height:16 across:2
			button bStrew "Nasyp / wykop" width:100 height:16
		
		)
		group "Include, node"
		(
			--button bPassive1Inc "Pasywne" width:70 height:16 across:2 
			button bActiveInc "Include" width:70 height:16 across:2 
			button bSignalInc "Semafory" width:70 height:16 
			button bIncTree "Zielen" width:70 height:16 across:2
			--button bIncRandomTree "Random Tree" width:70 height:16 across:2
 			button bModel "Model" width:70 height:16 
			button bPointers "Wskazniki" width:70 height:16 across:2
			button bHekto "Slupki Hektometrowe" width:120 height:16 
			button bSounds "Dzwieki" width:70 height:16 across:2 
			button bCustom "Custom" width:70 height:16
			button bLineCreate "Linie" width:70 height:16
		)
		group "Trakcja"
		(
			button bTraction "Druty" width:70 height:16 across:2
			button bGantryInc "Bramki" width:70 height:16 
			button bPowerInc "Podstacja" width:80 height:16 
		)
		group "Zdarzenia(events)"
		(
			button bSwitchEv "Zwrotnica" width:70 height:16 across:2
			button bLightsEv "Semafory" width:70 height:16
			button bTrackVelEv "Track vel" width:70 height:16 across:2
			button bMultipleEv "Multiple" width:70 height:16
		--	button bAnim "Animacja" width:70 height:16
			button bANGswitch "AngSwitch" width:70 height:16
		)
		group "Pojazdy"
		(
			button btrainset "Trainset" width:70 height:16 across:2
			button bDynamic "Dynamic" width:90 height:16 across:2
		)
        group "Eksportery"
		(
			button bSCMTerExport "Terrain Export" width:120 height:20 
			button bSCNExport "scn/inc Export" width:90 height:16 across:3
			button bT3DExport "t3d Export" width:70 height:16
			--button bB3DExport "e3d Export" width:70 height:16 tooltip:"w przyszlosci"
		    button bSCMExport "scm Export" width:70 height:16 
			button bEvExport "Event Export" width:70 height:16 across: 2
			button bdexport "Mesh Export" width:70 height:16
		)

		group "Inne"
		(
			button bDelExport "Delanuay mesh" height:16 across:2
			button bUstaw "Ustawienia" height:16
            button bScnImport "Scn importer" height:16 across:2
			button bScnUpdate "akt. skryptw" height:16 
		)

		fn removeRollouts =
		(
			removeRollout CreateNormalTrack MainFloater
			removeRollout CreateNormalRoad MainFloater
			removeRollout CreateNewStrew MainFloater
			removeRollout CreateNormalRiver MainFloater
			removeRollout CreateSwitch MainFloater
			removeRollout CreateModel MainFloater
			removeRollout CreateEventSwitch MainFloater
			removeRollout CreateEventLights MainFloater
--			removeRollout CreateEventDynVel MainFloater
			removeRollout CreateEventTrackVel MainFloater
			removeRollout CreateEventMultiple MainFloater
			removeRollout CreateIncActive MainFloater
			removeRollout CreateSound MainFloater
			removeRollout CreateSignal MainFloater
			removeRollout CreateIncTree MainFloater
			removeRollout CreateIncRandomTree MainFloater
			removeRollout CreateCustom MainFloater
			removeRollout CreateHekto MainFloater
			removeRollout CreatePointers MainFloater
			removeRollout SCNExport MainFloater
			removeRollout SCMExport MainFloater
			removeRollout SCMTerExport MainFloater
			removeRollout NullCheck MainFloater
			removeRollout ScnImport MainFloater
			removeRollout CreateTrainSet MainFloater
			removeRollout CreateDynamic MainFloater
			removeRollout ustawienia MainFloater
--						
			removeRollout awa MainFloater
			removeRollout EvExport MainFloater
			removeRollout dExport MainFloater
--			removeRollout atmo MainFloater
			removeRollout CreateAnglSwitch MainFloater

			removeRollout ATMDef MainFloater
			removeRollout ttttrainset MainFloater
			removeRollout T3DExport MainFloater
			--removeRollout B3DExport MainFloater
			removeRollout DelExport MainFloater
--			removeRollout DelImport MainFloater
			removeRollout CreateTraction MainFloater			
			removeRollout CreateGantryInc MainFloater			
			removeRollout CreatePowerInc MainFloater	
			removeRollout CreateLine MainFloater	
--	zamykanie gwnego
			Main.open = false;		
		)
		
		on main open do
 		(
		scriptDirectory= (getDir #scripts)+"\\EU07\\"
		DirEu = getINISetting (scriptDirectory+"ustawienia.ini" ) "ustawienia_glowne" "DirEu"
		if DirEu == "" then 
			(
			messageBox "Musisz ustawic sciezke dostepu do Symulatora"
			removeRollouts()
			addRollout ustawienia MainFloater
			
			)
 		)
	
		
		on bANGswitch pressed do
		(
			removeRollouts()
        	addRollout CreateAnglSwitch MainFloater
		)
		on bdexport pressed do
		(
			removeRollouts()
			addRollout dExport MainFloater
		)
		on bEvExport pressed do
		(
			removeRollouts()
			addRollout EvExport MainFloater
		)
		on brozkrz pressed do
		(
			removeRollouts()
		 	addRollout awa MainFloater
		)
		on bSCMExport pressed do
		(
			removeRollouts()
			addRollout SCMExport MainFloater
		)
		on bSCMTerExport pressed do
		(
			removeRollouts()
			addRollout SCMTerExport MainFloater
		)
		on bUstaw pressed do
		(
		    removeRollouts()
			addRollout ustawienia MainFloater
	    )
	    on btrainset pressed do
		(
			removeRollouts()
			addRollout CreateTrainSet MainFloater
		)
		on bDynamic pressed do
		(
			removeRollouts()
			addRollout CreateDynamic MainFloater
		)
		on bScnImport pressed do
		(
			removeRollouts()
			addRollout scnImport MainFloater
		)
		on bTrack pressed do
		(
			removeRollouts()
			addRollout CreateNormalTrack MainFloater
		)
		on bRoad pressed do
		(
			removeRollouts()
			addRollout CreateNormalRoad MainFloater
		)
		on bStrew pressed do
		(
			removeRollouts()
			addRollout CreateNewStrew MainFloater
		)
		on bRiver pressed do
		(
			removeRollouts()
			addRollout CreateNormalRiver MainFloater
		)
		on bSwitch pressed do
		(
			removeRollouts()
			addRollout CreateSwitch MainFloater
		)
		on bSounds pressed do
		(
			removeRollouts()
			addRollout CreateSound MainFloater
		)
		on bActiveInc pressed do
		(
			removeRollouts()
			addRollout CreateIncActive MainFloater
		)
		on bSignalInc pressed do
		(
			removeRollouts()
			addRollout CreateSignal MainFloater
		)
		on bIncTree pressed do
		(
			removeRollouts()
			addRollout CreateIncTree MainFloater
		)		
		on bIncRandomTree pressed do
		(
			removeRollouts()
			addRollout CreateIncRandomTree MainFloater
		)
		on bCustom pressed do
		(
			removeRollouts()
			addRollout CreateCustom MainFloater
		)
		on bHekto pressed do
		(
			removeRollouts()
			addRollout CreateHekto MainFloater
		)
		on bModel pressed do
		(
			removeRollouts()
			addRollout CreateModel MainFloater
		)
		on bTraction pressed do
		(
			removeRollouts()
			addRollout CreateTraction MainFloater
		)
		on bGantryInc pressed do
		(
			removeRollouts()			
            addRollout CreateGantryInc MainFloater
		)		
        on bPowerInc pressed do
		(
			removeRollouts()
			addRollout CreatePowerInc MainFloater
		)
		on bSwitchEv pressed do
		(
			removeRollouts()
			addRollout CreateEventSwitch MainFloater
		)
		on bLightsEv pressed do
		(
			removeRollouts()
			addRollout CreateEventLights MainFloater
		)
		on bDynVelEv pressed do
		(
			removeRollouts()
			addRollout CreateEventDynVel MainFloater
		)
		on bTrackVelEv pressed do
		(
			removeRollouts()
			addRollout CreateEventTrackVel MainFloater
		)
		on bMultipleEv pressed do
		(
			removeRollouts()
			addRollout CreateEventMultiple MainFloater
		)
		on bSCNExport pressed do
		(
			removeRollouts()
			addRollout SCNExport MainFloater
			addRollout ATMDef MainFloater
			addRollout ttttrainset MainFloater
			addRollout NullCheck MainFloater
		)
		on bT3DExport pressed do
		(
			removeRollouts()
			addRollout T3DExport MainFloater
		)

		on bB3DExport pressed do
		(
			
		--	removeRollouts()
		--	addRollout b3DExport MainFloater
		)
		
		on bDelExport pressed do
		(
			removeRollouts()
			addRollout DelExport MainFloater
		)
		on bDelImport pressed do
		(
			removeRollouts()
			addRollout DelImport MainFloater
		)
		
		on bPointers pressed do
		(
			removeRollouts()
			addRollout CreatePointers MainFloater	
			DirEu = ""
		)
		
		on bLineCreate pressed do
		(
			removeRollouts()
			addRollout CreateLine MainFloater	
	
		)		
		
		on bScnUpdate pressed do
		(
		
			if(doesFileExist "temp_update.exe") then 
					(
					
					deleteFile (((getDir #scripts)+"\\EU07\\") + "updatescripts.exe")
					renameFile (((getDir #scripts)+"\\EU07\\") + "temp_update.exe") (((getDir #scripts)+"\\EU07\\") + "updatescripts.exe")
					
					)
			scr = (GetDir #maxroot) + "temp_update.exe"
			print scr
			if(doesFileExist scr) then 
					(
					deleteFile "updatescripts.exe"
					copyFile scr ((getDir #scripts)+"\\EU07\\updatescripts.exe")
					deleteFile scr 
					
					)
			
			
			ShellLaunch ("\""+scriptDirectory+"updatescripts.exe"+"\"") ""
		)
		
)
addRollout Main MainFloater
--getFile()









