utility ScnImport "Scn Importer" width:162 height:300
(
	-- listbox list ""
	-- listbox list2 ""
	button btn_import "Import SCN"
	label lb1 ""
	checkbox cb_invert "Odwroc tekstury DDS" checked:true
	label lb2 ""
	
	group "Co zrobic gdy ilosc tekstur przekroczy 24? "
	(
	radiobuttons radio1 "" labels:#("mergowanie do jedneggo pliku \"max\"", "podzial i zapis na pliki \"max\"") align:#left
	)
	
	global tr
	global fp
	global ostream
	global plikiMax = 1
	global fname
	
	
function GetDirEu = 
(
		scriptDirectory= (getDir #scripts)+"\\EU07\\"
		DirEu = getINISetting (scriptDirectory+"ustawienia.ini" ) "ustawienia_glowne" "DirEu"
		if DirEu == undefined then messageBox "Musisz ustawic ciezke dostepu do Symulatora"
		return DirEu
		
) 



-- Dr Dg Db Sr Sg Sb
function CheckMaterial tekstura Ar Ag Ab=
(


			for i=1 to 24 do
				(
					
				
					if  (meditMaterials[i].maps[2] != undefined AND ((meditMaterials[i].ambient.r as string) == (Ar as string)) ) then  
					(
					
						if ((filenameFromPath meditMaterials[i].maps[2].filename) == (filenameFromPath tekstura)) then return i 

					)
					
					if (tekstura == "none") then
						(
						-- 
						if( meditMaterials[i].maps[2] == undefined AND ( meditMaterials[i].ambient.r as string) == (Ar as string) AND (meditMaterials[i].ambient.g as string) == (Ag as string)) then return i
						)
				
				
				)
				return 0
)



function Mapping obj vertsT=
(
for f =1 to obj.numverts do --for each face in the mesh
	(
	SetTVert obj f vertsT[f]
	)


	for f = 1 to obj.numfaces do
	(
	setTVFace obj f (getface obj f)
	)
	
	
update obj
)


	function ImportATMDefs =
	(
		local node
		node= box pos:[0,0,0] boxsize:[3,3,3] wireColor:(color 0 255 0)
		stl = readChar ostream
		stl = Format ("atmo % % %  % %  % % % endatmo\n") ("%") ("%") ("%") ("%") ("%") ("%") ("%") ("%") from:ostream
		print stl;
		setUserProp node "ExportString" stl
	)

	function ImportLightDefs =
	(
		local node2
		node2= Dummy pos:[0,0,0] boxsize:[3,3,3] wireColor:(color 0 255 0)
		stll = Format ("light % % %  % % %  % % %  % % % endlight\n") ("%") ("%") ("%") ("%") ("%") ("%") ("%") ("%") ("%") ("%") ("%") ("%") from:ostream
		setUserProp node2 "ExportString" stll.value as string
	)
	function ImportCameraDefs =
	(
		local node3
		node3= Dummy pos:[0,0,0] boxsize:[3,3,3] wireColor:(color 0 255 0)

		stlll = Format ("camera % % %  % % % endcamera\n") ("%") ("%") ("%") ("%") ("%") ("%") from:ostream
		setUserProp node3 "ExportString" stlll.value as string
	)

	function ImportTrack maxVisLen minVisLen nodeName nodeType=
	(
		--we read other vars
		PropertiesLine = readLine ostream
		--explode line to array
		PropertiesArray = filterString PropertiesLine "  "
		print (Format ("Import track: nPArray % ") PropertiesArray)
		local TextureArray
		if PropertiesArray[8] == "vis" then
		(
			--if track is visibile that next line is line whith textures
			TextureLine = readLine ostream
			--explode line to array
			TextureArray = filterString TextureLine "  "
			--print (Format ("TArray % ") TextureArray)
		)
		--read lines whith points and vectors
		Point1Line = readLine ostream
		if Point1Line[1] == "/" AND Point1Line[2] == "/" then Point1Line = readLine ostream
		Point1Array = filterString Point1Line "  "		
		P1 = [-Point1Array[1] as float,Point1Array[3] as float,Point1Array[2] as float]
		--print (Format ("P1Array % ") Point1Array)
		Vector1Line = readLine ostream
		Vector1Array = filterString Vector1Line "  "
		V1 = [-Vector1Array[1] as float,Vector1Array[3] as float,Vector1Array[2] as float]
		--print (Format ("V1Array % ") Vector1Array)
		Vector2Line = readLine ostream
		Vector2Array = filterString Vector2Line "  "
		V2 = [-Vector2Array[1] as float,Vector2Array[3] as float,Vector2Array[2] as float]
		--print (Format ("V2Array % ") Vector2Array)
		Point2Line = readLine ostream
		Point2Array = filterString Point2Line "  "
		P2 = [-Point2Array[1] as float,Point2Array[3] as float,Point2Array[2] as float]
		--print (Format ("P2Array % ") Point2Array)
		--read radius line
		Radius1Line = readLine ostream
		Radius1Array = filterString Radius1Line "  "
		--print (Format ("R1Array % ") Radius1Array)
		--if this node is switch we read another points and vecs
		local Point3Array, Point4Array, Radius2Array, P3, P4
		if nodeType == "switch" then
		(
			--read lines whith points and vectors
			Point3Line = readLine ostream
			Point3Array = filterString Point3Line "  "
			P3 = [-Point3Array[1] as float,Point3Array[3] as float,Point3Array[2] as float]
			--print (Format ("P3Array % ") Point3Array)
			Vector3Line = readLine ostream
			Vector3Array = filterString Vector3Line "  "
			V3 = [-Vector3Array[1] as float,Vector3Array[3] as float,Vector3Array[2] as float]
			--print (Format ("V3Array % ") Vector3Array)
			Vector4Line = readLine ostream
			Vector4Array = filterString Vector4Line "  "
			V4 = [-Vector4Array[1] as float,Vector4Array[3] as float,Vector4Array[2] as float]
			--print (Format ("V4Array % ") Vector4Array)
			Point4Line = readLine ostream
			Point4Array = filterString Point4Line "  "
			P4 = [-Point4Array[1] as float,Point4Array[3] as float,Point4Array[2] as float]
			--print (Format ("P4Array % ") Point4Array)
			--read radius line
			Radius2Line = readLine ostream
			Radius2Array = filterString Radius2Line "  "
			--print (Format ("R2Array % ") Radius2Array)
		)
		--in this line it might be the event line, the velocity line or endtrackline
		--that is cause why we read this line and check the first element
		local EndTrack = false
		local Event0,Event1,Event2,Velocity
		while not EndTrack do
		(
			local VLine = readLine ostream
			local VArray = filterString VLine "  "
			--print (Format ("VArray % ") VArray)
			if VArray[1] == "event0" then
				Event0 = VArray[2]
			else if VArray[1] == "event1" then
				Event1 = VArray[2]
			else if VArray[1] == "event2" then
				Event2 = VArray[2]
			else if VArray[1] == "velocity" then
				Velocity = VArray[2]
			else if VArray[1] == "endtrack" then
				EndTrack = true
		)
		disableSceneRedraw()
		l = line name:nodeName pos:P1
		addNewSpline l
		--print V1
		if (V1 == [0,0,0]) then
		(
			addKnot l 1 #bezier #line P1 P1 (P1+V1)
			addKnot l 1 #bezier #line P2 (P2+V2) P2
		)
		else
		(
			addKnot l 1 #bezier #curve P1 P1 (P1+V1)
			addKnot l 1 #bezier #curve P2 (P2+V2) P2
		)
		updateShape l
		if nodeType == "switch" then
		(
			m = line name:nodeName pos:P3
			addNewSpline m
			if (V3 == [0,0,0]) then
			(
				addKnot m 1 #bezier #line P3 P3 (P3+V3)
				addKnot m 1 #bezier #line P4 (P4+V4) P4
			)
			else
			(
				addKnot m 1 #bezier #curve P3 P3 (P3+V3)
				addKnot m 1 #bezier #curve P4 (P4+V4) P4
			)
			updateShape m
			addAndWeld l m -1
		)
		tr = l
		setUserProp tr "Type" nodeType
		setUserProp tr "Radius1" Radius1Array[1]
		if (Radius2Array != undefined) then	setUserProp tr "Radius2" Radius2Array[1]
		setUserProp tr "Roll1" Point1Array[4]
		setUserProp tr "Roll2" Point2Array[4]
		setUserProp tr "MaxDist" maxVisLen
		setUserProp tr "MinDist" minVislen
		setUserProp tr "TrackWidth" PropertiesArray[2]
		setUserProp tr "Friction" PropertiesArray[3]
		setUserProp tr "SoundDist" PropertiesArray[4]
		setUserProp tr "Quality" PropertiesArray[5]
		setUserProp tr "DamageFlag" PropertiesArray[6]
		setUserProp tr "Environment" PropertiesArray[7]
		setUserProp tr "Visibility" PropertiesArray[8]
		if TextureArray != undefined then
		(
			setUserProp tr "Tex1" TextureArray[1]
			setUserProp tr "TexLength" TextureArray[2]
			setUserProp tr "Tex2" TextureArray[3]
			setUserProp tr "TexPar1" TextureArray[4]
			setUserProp tr "TexPar2" TextureArray[5]
			setUserProp tr "TexPar3" TextureArray[6]
		)
		else
		(
			setUserProp tr "Tex1" "Rail_screw_used1"
			setUserProp tr "TexLength" "4"
			setUserProp tr "Tex2" "TpBpS-new2.tex"
			setUserProp tr "TexPar1" "0.2"
			setUserProp tr "TexPar2" "0.5"
			setUserProp tr "TexPar3" "1.1"
		)
		if (Event0 != undefined) then
			setUserProp tr "Event0" Event0
		if (Event1 != undefined) then
			setUserProp tr "Event1" Event1
		if (Event2 != undefined) then
			setUserProp tr "Event2" Event2
		if (Velocity != undefined) then
			setUserProp tr "Velocity" Velocity
		setUserProp tr "Length" PropertiesArray[1]
		if nodeType == "normal" then
			tr.wireColor = (color 8 8 136)
		else if nodeType == "switch" then
			tr.wireColor = (color 87 224 87)
		else if nodeType == "road" then
			tr.wireColor = (color 128 50 50)
		else if nodeType == "river" then
			tr.wireColor = (color 20 50 200)
		enableSceneRedraw()
	)

	function ImportTraction maxVisLen minVisLen=
	(
		--we read other vars
		PropertiesLine = readLine ostream
		--explode line to array
		PropertiesArray = filterString PropertiesLine "  "
		print (Format ("PArray % ") PropertiesArray)
		--read lines whith points
		Point1Line = readLine ostream
		Point1Array = filterString Point1Line "  "
		P1 = [-Point1Array[1] as float,Point1Array[3] as float,Point1Array[2] as float]
		--print (Format ("P1Array % ") Point1Array)
		Point2Line = readLine ostream
		Point2Array = filterString Point2Line "  "
		P2 = [-Point2Array[1] as float,Point2Array[3] as float,Point2Array[2] as float]
		--print (Format ("P2Array % ") Point2Array)
		Point3Line = readLine ostream
		Point3Array = filterString Point3Line "  "
		P3 = [-Point3Array[1] as float,Point3Array[3] as float,Point3Array[2] as float]
		--print (Format ("P3Array % ") Point3Array)
		Point4Line = readLine ostream
		Point4Array = filterString Point4Line "  "
		P4 = [-Point4Array[1] as float,Point4Array[3] as float,Point4Array[2] as float]
		--print (Format ("P4Array % ") Point4Array)
		--we read other vars
		Properties2Line = readLine ostream
		--explode line to array
		Properties2Array = filterString Properties2Line "  "
		--print (Format ("P2Array % ") Properties2Array)
		
		
		--dodanie slupa
		--slupLine = readLine ostream
		--slupArray = filterstring slupLine " "
		
		--if slupArray[0] == "include" then print (Format("include % % %") slupArray[0] slupArray[1] slupArray[2])
		--print (Format("include $ $ $") slupArray[0] slupArray[1] slupArray[2])
		
		--in this line it might be the event line or endtracktionline
		--that is cause why we read this line and check the first element
		local EndTraction = false
		local CurrentEvent
		while not EndTraction do
		(
			local VLine = readLine ostream
			local VArray = filterString VLine "  "
			--print (Format ("VArray % ") VArray)
			if VArray[1] == "CurrentEvent" then
				CurrentEvent = VArray[2]
			else if VArray[1] == "endtraction" then
				EndTraction = true
		)
		
		disableSceneRedraw()
		l = line name:PropertiesArray[1] pos:P1
		addNewSpline l
		addKnot l 1 #bezier #curve P1 P1 P1
		addKnot l 1 #bezier #curve P2 P2 P2
		updateShape l
		tr = l
		setUserProp tr "Type" "traction"
		setUserProp tr "MaxDistance" maxVisLen
		setUserProp tr "MinDistance" minVislen
		setUserProp tr "NominalVoltage" PropertiesArray[2]
		setUserProp tr "MaxCurrent" PropertiesArray[3]
		setUserProp tr "Resistivity" PropertiesArray[4]
		setUserProp tr "Material" PropertiesArray[5]
		setUserProp tr "WireThickness" PropertiesArray[6]
		setUserProp tr "DamageFlag" PropertiesArray[7]
		setUserProp tr "h1" (P3[3] - P1[3])
		setUserProp tr "h2" (P4[3] - P2[3])
		setUserProp tr "hMin" Properties2Array[1]
		setUserProp tr "DeltaL" Properties2Array[2]
		setUserProp tr "Wires" Properties2Array[3]
		setUserProp tr "WireOffset" Properties2Array[4]
		setUserProp tr "Visibility" Properties2Array[5]
		if (CurrentEvent != undefined) then
		setUserProp tr "CurrentEvent" CurrentEvent
		tr.wireColor = (color 0 0 255)
		enableSceneRedraw()
	)
	
	function ImportTriangles maxVisLen minVisLen=
	(
	
			 
		
				if radio1.state == 1 then
				(
				savemaxfile  ((getFilenamePath fname )+"merge.max")
				if checkForSave() do resetMaxFile #noPrompt
				mergemaxfile  ((getFilenamePath fname )+"merge.max")
				deleteFile  ((getFilenamePath fname )+"merge.max")
				print "mergowanie"
				)
				
				if radio1.state == 2 then
				(
				savemaxfile  ((getFilenamePath fname )+"merge" +(plikiMax as string)+ ".max")
				if checkForSave() do resetMaxFile #noPrompt
		
				print ("nowy plik " + ("merge" +(plikiMax as string)+ ".max"))
				plikiMax += 1

				)
		
	
		textall = "node " + (maxVisLen as string) + " " + (minVisLen as string) + " none triangles "
		pf1 = filepos ostream
		seek ostream (pf1-textall.count)	
	
	
		
		vert_array = #()
		vert_Tarray = #()
		vert_Narray = #()

		face_array = #()
		vert_count = 0	
		
		pierwszy = 1
		name = "none"
		tekstura = ""
		PArrayG = #()
		
	while not (eof ostream) do

	(

		
		
		PLine = readLine ostream
		PArray = filterString PLine " "	
		
		if pierwszy == 1 then
			(
			name = PArray[4]
			tekstura = PArray[20]
			pierwszy = 0
			)

		
		if ((PArray[4] as string) != name) OR (PArray[5] as string) !="triangles" OR (PArray[20] as string) != tekstura then
				(

			
				pf1 = filepos ostream
				seek ostream (pf1-PLine.count)	
				exit
				) 		
		else
		(

		PArrayG = PArray	

	
		Pos1 = #()	
		Pos1 = filterString (readLine ostream) " \t"
		while not(matchPattern Pos1[1] pattern:"endtri")do
			(
			Pos2 = filterString (readLine ostream) " \t"
			Pos3 = filterString (readLine ostream) " \t"	
			
			local fl = Pos1[1] as float

			Pos1[1] = fl-fl-fl
			fl = Pos2[1] as float

			Pos2[1] = fl-fl-fl
			fl = Pos3[1] as float

			Pos3[1] = fl-fl-fl
		
			v1 = [Pos1[1] as float,Pos1[3] as float,Pos1[2] as float]
			v2 = [Pos2[1] as float,Pos2[3] as float,Pos2[2] as float]
			v3 = [Pos3[1] as float,Pos3[3] as float,Pos3[2] as float]

			append vert_array v1
			append vert_array v2
			append vert_array v3
			
			v4 = [Pos1[4] as float,Pos1[6] as float,Pos1[5] as float]
			v5 = [Pos2[4] as float,Pos2[6] as float,Pos1[5] as float]
			v6 = [Pos3[4] as float,Pos3[6] as float,Pos1[5] as float]
			
			append vert_Narray v4
			append vert_Narray v5
			append vert_Narray v6
			
			v7 = [Pos1[7] as float,Pos1[8] as float,0]
			v8 = [Pos2[7] as float,Pos2[8] as float,0]
			v9 = [Pos3[7] as float,Pos3[8] as float,0]
			
			append vert_Tarray v7
			append vert_Tarray v8
			append vert_Tarray v9
		
			append face_array [vert_count+1,vert_count+2,vert_count+3]
			vert_count += 3
			
			if ((Pos3[9] as String)=="endtri")then
				(
				Pos1 = filterString ("endtri") " \t"
				)
			else
				(
				Pos1 = filterString (readLine ostream) " \t"	
				)	
			)
		--EndTri = readLine ostream
		)
		)	

	
		m = mesh vertices:vert_array faces:face_array
		--if  m.numfaces != 0 then meshop.flipNormals m #{1..m.numfaces}	
		
		
			
		
		sciezka = (GetDirEu() as string) + "\\textures\\" + (PArrayG[20] as string)
		
		
	
				
				

		
	

			
			
			
		


		m.numtverts = m.numverts	
		if m.numverts != 0 then
		(
			
		buildTVFaces m	
		)
		
		for i=1 to m.numverts do
		(
		
		setNormal m i vert_Narray[i]
		SetTVert m i vert_Tarray[i]
		)

		for f = 1 to m.numfaces do
		(
		setTVFace m f (getface m f)
		)		
			


		
		

	)


	function ImportModel maxVisLen minVisLen nameModel=
	(
			--doczyrtanie lini do konca
			PLine = readLine ostream
			--filtr
			PArray = filterString PLine ";"
			
			--print (Format ("Rozpoznano model: % % " ) PArray[5] nameModel )
			print (Format("node % % ") PArray[1] PArray[2])
			--tworzenie nowego punktu
			node = Point pos:[-PArray[1] as float, PArray[3] as float, PArray[2] as float] cross:false axistripod:true box:true constatnsscreensize:true
			node.rotation.z_rotation = PArray[4] as float
			--tworzenie strongu do eksportu 
			--Tu byl blad ---- zglosi Quark-t
			
			str = "node;"+maxVisLen as string +";"+minVisLen as string + ";%;model;%;%;%;%"
			
				for x=5 to 12  do
					(
					if pArray[x] != undefined then
						(
					pos1 = FindString pArray[x] "endmodel"
						if pos1 == undefined then
							(
							str += ";"+pArray[x]
							)
						else str += ";endmodel"	
						)
					
					)
					
			setUserProp node "ExportString" str

			node.name = nameModel	
			node.wireColor = (color 100 0 100)
	
	
	)
	function ImportNode =
	(
		--skipping white space
		--skipSpace
--		typeOfThing = readDelimitedString ostream " "
		--explode line/word to array
		--typeOfThingArray = filterString typeOfThing ";"
		--print (Format ("TypeOfThingArray % ") typeOfThingArray)
		
		
		
		skipToString ostream "node"
		--anti eof
		
		if not (eof ostream) then
		(
				
			--must to select next var skipping whitespace
			readChar ostream
	
			--read first var
			maxVisLen = readDelimitedString ostream "; "
		
			--read second var
			minVisLen = readDelimitedString ostream "; "
			--read the name of node
			nodeName = "none"
			local nn = false
			while not nn do
				(
				nodeName = readDelimitedString ostream "; "
				if nodeName != "" then
					nn = true
				)
			
			
			typeOfNode = readDelimitedString ostream "; "
	
			--print formated vars to the Listener
			print (Format ("node % % % % ") maxVisLen minVisLen nodeName typeOfNode)
			--check type of node
			if typeOfNode == "track" then
				(
				--this is a kind of track, check what track it is
				--read
				typeOfTrack = readDelimitedString ostream " "
				--check
				if typeOfTrack == "normal" or typeOfTrack == "switch" or typeOfTrack == "road" or typeOfTrack == "river" then
					(
					--execute function to read a vars
					ImportTrack maxVisLen minVisLen nodeName typeOfTrack
					)
				)
			if typeOfNode == "traction" then
				(
				ImportTraction maxVisLen minVisLen
				)
			if typeOfNode == "triangles" then
				(
				ImportTriangles maxVisLen minVisLen
				)
			
			if typeOfNode == "model" then
				(   

				ImportModel maxVisLen minVisLen nodeName 
				)
			
		)
		
	)

	function ImportInclude =
	(
		skipToString ostream "include"
		
		
		--ps = ostream.pos
		--print (Format("pozycja: % ") ps)
		
		if not (eof ostream) then
		(
			--odczytujemy linie tekstu
			PLine = readLine ostream
			
			--reset nodeType
			nodeType = "none"
			
			--filtracja przez znaki dopuszczalne dla slupow trakcyjnch
			-- reakcja na slup trakcyjny 		
			PArrayTr = filterString PLine " "
				if(PArrayTr.count > 4) then 
				(
				nodeType = "trakcion"
				
				--przypadek SHP
				if (PArrayTr[2] as float) == undefined then 	
						(
						
						node = Point pos:[-PArrayTr[3] as float, PArrayTr[5] as float, PArrayTr[4] as float] cross:false axistripod:true box:true constatnsscreensize:true
						node.rotation.z_rotation = PArrayTr[6] as float				
			
						if (PArrayTr[6] as string) != "end" then str = "include "+PArrayTr[1]+" % % % % % "+PArrayTr[6]+" end"
						else str = "include "+PArrayTr[1]+" % % % % %  end"
						
						setUserProp node "ExportString" str
						node.name = PArrayTr[2]		
						node.wireColor = (color 17 195 100)
						)
						
				else
				(		
						
						
						
					
						node = Point pos:[-PArrayTr[2] as float, PArrayTr[4] as float, PArrayTr[3] as float] cross:false axistripod:true box:true constatnsscreensize:true
						node.rotation.z_rotation = PArrayTr[5] as float				
			
						if (PArrayTr[6] as string) != "end" then str = "include % % % % % "+PArrayTr[6]+" end"
						else str = "include % % % % %  end"
						print (Format("slup - %") str  ) 
						setUserProp node "ExportString" str
						node.name = PArrayTr[1]		
						node.wireColor = (color 7 195 195)
				)
				)
				
			--filtr dla pozostalych	
			PArray = filterString PLine ";  "
			--wszystko co nie jest slupem trakcyjnym
			if nodeType != "trakcion" then
			(
			
			
			print (Format("include % % ") PArray[1] PArray[2])
			
			
			-- akcja dla rozjazdow. Jeli wystepuje to dopisuje inca do rozjazdu
			fRozj = 0
			fPosRozj = 0
			
			--sprawdzanie czy .inc ma ciag znakow "zwr" dla rozjazdow
			fPosRozj = FindString PArray[1] "zwr"
			if (fPosRozj as string) != "undefined" then
				(
				
				
				objName =PArray[2]

				objPath = execute ("$'"+objName + "'")
				--sprawdzanie czy instnieje taki oniekt
				if (objPath as string) != "undefined" then 
				(
				
				print (Format "Rozpoznano rozjazd: % " PArray[1])
			
				strRozj = "include;"+PArray[1]+";%;%;%;%;%;"+PArray[7]+";end"
				setUserProp objPath "ExportString" strRozj			
				)
				else
				(
				
				node = Point pos:[-PArray[3] as float, PArray[5] as float, PArray[4] as float] cross:false axistripod:true box:true constatnsscreensize:true
				node.rotation.z_rotation = PArray[6] as float	

			
				node.wireColor = (color 255 128 0)
				str =  "include;"+PArray[1]+";"+PArray[2]+";%;%;%;%;"+PArray[7]+";end"	
				
				

				setUserProp node "ExportString" str
				node.name = PArray[2]					
				)
				
				
				)
				
			else
				(
			
			--odczytywanie czy na koncu jest komentarz
			nodeType = undefined
			pos2 = FindString PArray[PArray.count] "//"
			if pos2 != undefined then
				(
				nodeType = (subString PArray[PArray.count] pos2 -1)
				
				)
			

--funkcja doczytuje parametry do konca
function setstr ciag posA=
	(
	strong = ""
	for i=posA to 12 do	
		(
		if ciag[i] != undefined then
			(
								
						pos1 = FindString ciag[i] "end"
						pos22 = FindString ciag[i] "//"
						if pos1 == undefined AND pos22 == undefined then
							(
							strong += ";"+ciag[i]
							)
						if pos1 != undefined then strong += ";end"	

			)
		
		)
		return strong
	
	)


			if ((PArray[2] as float) != undefined) AND ((PArray[3] as float) != undefined) AND ((PArray[4] as float) != undefined)  AND ((PArray[5] as float) != undefined) then
				(
			
				node = Point pos:[-PArray[2] as float, PArray[4] as float, PArray[3] as float] cross:false axistripod:true box:true constatnsscreensize:true
				node.rotation.z_rotation = PArray[5] as float
				node.wireColor = (color 228 64 160)
			
				str = "include;"+PArray[1]+";%;%;%;%;%"
				str += (setstr PArray 6)
				
				setUserProp node "ExportString" str
				if nodeType != undefined then str += "  "+nodeType
				node.name = ";"	
			
				)
				

			else
			(
			if ((PArray[3] as float) != undefined) AND ((PArray[4] as float) != undefined) AND ((PArray[5] as float) != undefined)  AND ((PArray[6] as float) != undefined) then
				(	
		
				node = Point pos:[-PArray[3] as float, PArray[5] as float, PArray[4] as float] cross:false axistripod:true box:true constatnsscreensize:true
				node.rotation.z_rotation = PArray[6] as float
			
				str = "include;"+PArray[1]+";%;%;%;%;%"
				str += (setstr PArray 7)
				if nodeType != undefined then str += "  "+nodeType
				setUserProp node "ExportString" str
				node.name = PArray[2]	
			
				)
			)		
			
			
		--sprawdzanie typu includ'a

				
			--akcje dla roslinnoci
			if nodeType == "//Plants" or PArray[1] == "tree.inc" or PArray[1] == "tree3plane.inc" then
			(
				node.wireColor = (color 64 128 32)
			)
			--akcje dla aktywnych
			if nodeType == "//Active" then
			(
				node.wireColor = (color 255 128 0)
			)
			--akcje dla pasywnych
			if nodeType == "//Passive" then
			(
				node.wireColor = (color 128 64 16)
			)
			--akcje dla odcinkow zasilania
			if nodeType == "//Power" then
			(
				node.wireColor = (color 200 0 0)
			)
			--akcje dla semaforow
			
			poss = FindString PArray[1] "SS5"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "SS4"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "SS3"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "SS2"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "ZS2"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "ZS1"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "TS2"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "TS1"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "ms2"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "ms1"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "PS"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "SBL"
			if poss == 1 then nodeType = "//Signal"
			poss = FindString PArray[1] "slupek-hm"
			if poss == 1 then nodeType = "//hekto"
			
			if nodeType == "//Signal" then
			(
				node.wireColor = (color 255 255 0)
				node.size = 8
			)
		
			
			if nodeType == "//hekto" then
			(
				node.wireColor = (color 99 18 52)
				node.size = 8
			)


			
			
			)
			
			)

		)
	)
	
	function ImportSCN filePosition=
	( --and ostream != undefined
		while not (eof ostream) do
		(
			--ImportATMDefs()
			--ImportLightDefs()
			--ImportCameraDefs()
			ImportNode()
		)
		
		seek ostream filePosition
		while not (eof ostream) do
		(
			ImportInclude()
		)
	)
		
	function GetOpenFileStream =
	(
		fname = GetOpenFileName types:"Scene other files(*.scn)|*.scn|Scene main files(*.scm)|*.scm|All Files(*.*)|*.*|"
		if fname == undefined then
			return undefined
		        
		ostream = openFile fname 
		if ostream == undefined then
		(
			MessageBox "Couldn't open file for reading !"
			return undefined
		)	
		return ostream
	)
	
	on btn_import pressed do
	(
	resetMaxFile()
		ostream = GetOpenFileStream()
		if ostream != undefined then
		(
			fp = filePos ostream
			
			ImportSCN fp
			Close ostream
		)
	)
	
	on cb_invert changed state do
	(
	if state == true then
	(

	for i = 1 to 24 do
	(
			if  (meditMaterials[i].maps[2] != undefined) then  
					(
						if((getFilenameType meditMaterials[i].maps[2].filename )== ".dds") then
						(
						meditMaterials[i].diffuseMap.coordinates.U_Angle = 180.0
					

						)
					)
	)
	)
	else 
	(
	for i=1 to 24 do
	(
			if  (meditMaterials[i].maps[2] != undefined) then  
					(
						if((getFilenameType meditMaterials[i].maps[2].filename )== ".dds") then
						(
						meditMaterials[i].diffuseMap.coordinates.U_Angle = 0.0
			

						)
					)
	)
	)

)

)