-- Poprawka ISDR
-- 03.12.2011

--zmienne 
	--drzewa wysokie iglaste
	tree2 = #( "l61_plants/#sosna1" ,"l61_plants/#sosna2" ,"l61_plants/#sosna3" ,"l61_plants/#swierk2" , "plants/#sosna1" , "plants/#sosna2" , "plants/#sosna3" , "plants/#sosna4" , "plants/#sosna5" , "plants/#sosna6" , "plants/#sosna7" ,  "plants/#swierk2" , "plants/#swierk4" , "plants/#swierk8" , "plants/#drzewo4" , "plants/rozi/#rozi_drzewo_1" )
	
	--drzewa wysokie lisciaste
	tree3 = #("plants/#brzoza1" , "l61_plants/#topola1" , "l61_plants/#topola2", "l61_plants/#drzewo1" , "l61_plants/#drzewo3" , "l61_plants/#drzewo4" , "l61_plants/#drzewo6" , "l61_plants/#drzewo7" , "l61_plants/#drzewo8" , "l61_plants/#drzewo9" , "plants/#dab1" , "plants/#dab2" , "plants/#drzewo_2" , "plants/#drzewo5" , "plants/#drzewo6" , "plants/#drzewo7" , "plants/#Jesion1" , "plants/rozi/#rozi_drzewo_10" , "plants/rozi/#rozi_drzewo_2" , "plants/rozi/#rozi_drzewo_3" , "plants/rozi/#rozi_drzewo_4" , "plants/rozi/#rozi_drzewo_5" , "plants/rozi/#rozi_drzewo_6" , "plants/rozi/#rozi_drzewo_7" , "plants/rozi/#rozi_drzewo_8" , "plants/rozi/#rozi_drzewo_9" )
	
	
	--dzewa niskie iglaste
	stree1 = #("plants/#sosenka1","plants/#topola2","plants/#drzewo3","plants/#drzewo_9","plants/#krzak_1","l61_plants/#krzak4","l61_plants/#krzak3","l61_plants/#drzewo2","l61_plants/#drzewo5","l61_plants/#sosna4","l61_plants/#sosna5","l61_plants/#sosna7","l61_plants/#sosna8"  )
	
	--drzewa niskie lisciaste
	stree2 = #("plants/#krzak1", "plants/#drzewo8", "plants/#JabNisk1" , "plants/#tree2" , "plants/#tree4" , "plants/#tree5" , "l61_plants/#drzewo5" , "l61_plants/#drzewo2" ,  "l61_plants/#krzak3" ,"l61_plants/#krzak4" , "plants/rozi/#rozi_drzewo_niskie_1" , "plants/rozi/#rozi_krzew_1" , "plants/rozi/#rozi_krzew_10" , "plants/rozi/#rozi_krzew_11" , "plants/rozi/#rozi_krzew_2", "plants/rozi/#rozi_krzew_3" , "plants/rozi/#rozi_krzew_4" , "plants/rozi/#rozi_krzew_5" , "plants/rozi/#rozi_krzew_6" , "plants/rozi/#rozi_krzew_7" , "plants/rozi/#rozi_krzew_8" , "plants/rozi/#rozi_krzew_9" )		
	
	grass = #("trawsko1" , "trawsko2" , "trawsko3")
	
--wysokoci
	-- drzewo wysokie
	Wwys = 19
	Wsze = 6
	Wrand = 4
	Wname = "tree.inc"
	--drzewo niskie
	Mwys = 5
	Msze = 3
	Mrand = 1
	Mname = "tree.inc"	
	--trawy
	Twys = 1
	Tsze = 3
	Trand = 1
	Tname = "grass_rot.inc"


rollout CreateIncTree "Create Include: Tree"
(

--	radioButtons tt "Type" labels:#(#Line, #Arc, #Flex) align:#left 

	editText eFileName "Nazwa pliku : " text:"tree.inc" 
	editText eName "(P1) Tekstura : " text:"plants/#drzewo_12" 
	
	
	editText ePar6 "(P6) Wysokosc[metr] : " text:"19.0" 
	spinner ePar8 "+ losowa wysokosc[metr] od 0 do : " type:#integer range:[0,20,4] align:#left	fieldWidth:50

	editText ePar7 "(P7) Szerokosc[metr] : " text:"6.0" 

	spinner ePar9 "Polozenie Z[metr] : " type:#float range:[-999999,999999,000.0000] align:#left

	group "Opcje losowania "
	(
	checkbox randT "losuj drzewko" 
	checkbox dWys "drzewa wysokie" checked:true across:3
	checkbox dNis "drzewa niskie" checked:true 
	checkbox dTra "trawy" checked:true 

	)
	


	button btn1  "stworz"
	--button btn2  "test"
	
	group "Segregacja drzew "
	(
	dropdownlist cTree "Segregacja drzew wg.: " items:#("wszystkie", "iglaste" , "lisciaste") selection:1
	
	)
	group "Drzewa Wysokie"
	(

	listbox List2 "Drzewa:" items:(tree2+tree3) height:10	
	
	)
	group "Drzewa Niskie"
	(

	listbox List1 "Drzewka:" items: (stree1+stree2) height:10 
	

	)

	group "trawy"
	(

	listbox List3 "Trawa: " items: grass heigth:5
	

	)
	button btn3  "edytuj liste drzew"
	checkbox loadB "Pokaz teksture"
	
	bitmap obraz 
	
	

	function GetDirEu = 
	(
		scriptDirectory= (getDir #scripts)+"\\EU07\\"
		DirEu = getINISetting (scriptDirectory+"ustawienia.ini" ) "ustawienia_glowne" "DirEu"
		if DirEu == undefined then messageBox "Musisz ustawic ciezke dostepu do Symulatora"

		return DirEu
		
	) 
	
	
	function LoadFromFile = 
	(
	sFname = (getDir #scripts) + "\\EU07\\zielen.txt"
	pPlik = openFile sFname mode:"r"
	if pPlik == undefined then 
		(
		--procedura braku pliku
		print "brak pliku z drzewami"		
		)
	else (
		--resetujemy tablice
		--drzewa wysokie iglaste
		tree2 = #()
		--drzewa wysokie lisciaste
		tree3 = #()
	
		--dzewa niskie iglaste
		stree1 = #()
		--drzewa niskie lisciaste
		stree2 = #()	
		
		--trawy
		grass = #()
		

	iSwitch = 0
	
	
	while (not (eof pPlik)) do
	(--wczytanie pliku
	
	linia = readLine pPlik --czytanie linii
	pos1 = findString linia "[WYSOKIE_LISCIASTE" 
	if pos1 != undefined then 
		(
		newL = subString linia 2 (linia.count-2)
		setting = filterString newL ";"
		
		for i = 1 to setting.count do
		(
		value = filterString setting[i] "="
		if value[1] == "wysokosc" then Wwys = (value[2] as integer)
		if value[1] == "szerokosc" then Wsze = (value[2] as integer)
		if value[1] == "random" then Wrand = (value[2] as integer)
		if value[1] == "nazwa" then Wname = (value[2] as string)
		)
		
		--utawienia domylne

		eFileName.text = Wname
		
		eName.text = (List2.selected as string)
		ePar6.text = Wwys as string
		ePar7.text = Wsze as string
		ePar8.value = Wrand as integer
		
		
		iSwitch = 1 --jak natrafi na tekst "[WYSOKIE_LISCIASTE]" to nadaje indeks 
		continue
		)

	pos1 = findString linia "[WYSOKIE_IGLASTE" 
	if pos1 != undefined then 
		(

		newL = subString linia 2 (linia.count-2)
		setting = filterString newL ";"
		
		for i = 1 to setting.count do
		(
		value = filterString setting[i] "="
		if value[1] == "wysokosc" then Wwys = (value[2] as integer)
		if value[1] == "szerokosc" then Wsze = (value[2] as integer)
		if value[1] == "random" then Wrand = (value[2] as integer)
		if value[1] == "nazwa" then Wname = (value[2] as string)
		)
		
		iSwitch = 2 --jak natrafi na tekst "[WYSOKIE_IGLASTE]" to nadaje indeks 
		continue
		)
		
	pos1 = findString linia "[NISKIE_LISCIASTE" 
	if pos1 != undefined then 
		(

		newL = subString linia 2 (linia.count-2)
		setting = filterString newL ";"
		
		for i = 1 to setting.count do
		(
		value = filterString setting[i] "="
		if value[1] == "wysokosc" then Mwys = (value[2] as integer)
		if value[1] == "szerokosc" then Msze = (value[2] as integer)
		if value[1] == "random" then Mrand = (value[2] as integer)
		if value[1] == "nazwa" then Mname = (value[2] as string)
		)
		
		iSwitch = 3 --jak natrafi na tekst "[NISKIE LICIASTE]" to nadaje indeks 
		continue
		)
		
	pos1 = findString linia "[NISKIE_IGLASTE" 
	if pos1 != undefined then 
		(

		newL = subString linia 2 (linia.count-2)
		setting = filterString newL ";"
		
		for i = 1 to setting.count do
		(
		value = filterString setting[i] "="
		if value[1] == "wysokosc" then Mwys = (value[2] as integer)
		if value[1] == "szerokosc" then Msze = (value[2] as integer)
		if value[1] == "random" then Mrand = (value[2] as integer)
		if value[1] == "nazwa" then Mname = (value[2] as string)
		)
		
		iSwitch = 4 --jak natrafi na tekst "[NISKIE_IGLASTE]" to nadaje indeks 
		continue
		)
		
	pos1 = findString linia "[TRAWY" 
	if pos1 != undefined then 
		(
	
		newL = subString linia 2 (linia.count-2)
		setting = filterString newL ";"
		
		for i = 1 to setting.count do
		(
		value = filterString setting[i] "="
		if value[1] == "wysokosc" then Twys = (value[2] as integer)
		if value[1] == "szerokosc" then Tsze = (value[2] as integer)
		if value[1] == "random" then Trand = (value[2] as integer)
		if value[1] == "nazwa" then Tname = (value[2] as string)
		)
		
		iSwitch = 5 --jak natrafi na tekst "[TRAWY]" to nadaje indeks 
		continue
		)
	

	pos1 = findString linia "//" --obsluga komentarzy
	if pos1 != undefined then 
		(
		linia = substring linia 1 (pos1-1)
		if linia == "" then continue
		)
	if linia == "" then continue --pusta linia
	
	case iSwitch of
	(
	1: (
			append tree3 linia	
		)
	2: (
			append tree2 linia	
		)
	3: (
			append stree2 linia	
		)	
	4: (
			append stree1 linia	
		)		
	5: (
			append grass linia	
		)
	
	)--end case
	
	
	)--end while
	
	--zwalniamy plik
	close pPlik
	)--end else
	
	--load to listbox 
	List2.items = (tree3+tree2)
	List1.items = (stree2+stree1)
	List3.items = grass
	
	)
	on CreateIncTree open do
	(
	LoadFromFile()

	)
	
	function RandomTree =
	(
	
	--standard
	iStart = 0
	iEnd = 5
	
	--przypadek 1 1 1
	if dWys.checked and dNis.checked and dTra.checked then (
	iStart = 0 
	iEnd = 5
	)
	
	--przypadek 1 0 0
	if dWys.checked and dNis.checked==false and dTra.checked==false then ( 
	iStart = 0 
	iEnd = 3
	)
	
	--przypadek 1 1 0
	if dWys.checked and dNis.checked and dTra.checked==false then (
	iStart = 0 
	iEnd = 4
	)
	
	--przypadek 1 0 1
	if dWys.checked and dNis.checked==false and dTra.checked then (
	iStart = 0 
	iEnd = 4	
	)	
	
	--przypadek 0 1 0
	if dWys.checked==false and dNis.checked and dTra.checked==false then (
	iStart = 4 
	iEnd = 4
	)
	
	--przypadek 0 0 1
	if dWys.checked==false and dNis.checked==false and dTra.checked then (
	iStart = 5 
	iEnd = 5
	)
	
	--przypadek 0 1 1
	if dWys.checked==false and dNis.checked and dTra.checked then (
	iStart = 4 
	iEnd = 5
	)
	
	--przypadek 0 0 0
	if dWys.checked==false and dNis.checked==false and dTra.checked==false then (
	messageBox "Czy nie zapomniales wybrac ktore drzewe ma losowac?" title:"Eu07 MaSzyna"
	)
	
	--losowanie typu drzewa
	RandTre= random iStart iEnd
	
	
	--przypadek 1 0 1 Na koniec 
	if dWys.checked and dNis.checked==false and dTra.checked then (
	if RandTre == 4 then RandTre = 5
	)
	
	if RandTre <= 3 then
		(
		
		RandWT = random 1 List2.items.count
		List2.selection = RandWT
		
		eFileName.text = Wname
		
		eName.text = (List2.selected as string)
		ePar6.text = Wwys as string
		ePar7.text = Wsze as string
		ePar8.value = Wrand as integer
		
		)
		
		if RandTre == 4 then
		(
		
		RandWT = random 1 List1.items.count
		List1.selection = RandWT
		eFileName.text = Mname
		
		eName.text = List1.selected
		ePar6.text = Mwys as string
		ePar7.text = Msze as string
		ePar8.value = Mrand as integer
		)
		
		if RandTre == 5 then
		(
		
		RandWT = random 1 List3.items.count
		List3.selection = RandWT
		eFileName.text = Tname
		
		eName.text = List3.selected
		ePar6.text = Twys as string
		ePar7.text = Tsze as string
		ePar8.value = Trand as integer
		)
		--print RandTre
	
	)
	
	tool CreateObject
	( 
	
		local node
		on mousePoint clickno do
		
		
			if clickno != -1 then
			(
			
	
		        if clickno == 1 then 
			(
			
			)

			else
			(
			
				if randT.checked == true then RandomTree()
				
				RandHei= random 0 ePar8.value
				
				gridPoint= gridPoint+[0,0,ePar9.value]
				
				node= Point pos:gridPoint cross:false axistripod:true box:true 				constatnsscreensize:true size:(ePar7.text as integer) wireColor:(color 64 128 32)
				str= "include;"+eFileName.text+";%;%;%;%;%;"
				if eFileName.text == "grass_rot.inc" then str += "%;%;"
				str= str+((ePar6.text as integer)+RandHei ) as string+";"
				str= str+ePar7.text+";end //Plants"
				setUserProp node "ExportString" str
				if (eName.text=="") then
					nodeName= "none"
				else
--					if (getNodeByName eName.text)==undefined then
						nodeName= eName.text
--					else
--						nodeName= uniqueName eName.text
				node.name= nodeName				
				
			)

			)
			
				
			


			else
			(
			
			#stop						
				
			)
		on mouseMove clickno do
		(
			
		)
	) 


tool PointCreator 
(

local p, createpoint

fn createpoint = in coordsys grid p=point pos:gridPoint
on mousePoint clickno do
	(
	if clickno == 1 then createPoint()

	else if p != undefined do (p.pos=gridPoint;p=undefined)
	)

on mouseMove clickno do
	(
	if p != undefined then p.pos=gridPoint
	else if lbutton do createPoint()
	)
)


function klik=
(
local pointT
pointT = [0,0,0]
pointE = pickPoint relativeTo:pointT
print (pointT as string)
print (pointE as string)

)

	on btn1 pressed do
	(
		startTool CreateObject		
	)	


	on btn3 pressed do
	(
		
		ShellLaunch ("\""+ ((getDir #scripts)+"\\EU07\\") +"zielen.txt"+"\"") ""
		
		
	)
	
	on btn2 pressed do
	(
		klik()
		
		
	)	
	
	
	function RotateBitmap FName = 
	(
	
		b = openBitMap FName
		if((b as string) == "undefined") then return 0

	w = b.width
	h = b.height
		
	brev = bitmap w h 
		
	for r=0 to h-1 do
	(  
	

    pixels=getpixels b [0,r] w 
	if (pixels[1] != undefined) then
	(             -- read in the column of pixels
	setpixels brev [0,w-r] pixels
	)

    ) 
	return brev
	)
	
	
	
	on cTree selected i do
	(
	--drzewa wszystkie
	if(i == 1) then
		(
		
		List2.items = (tree2 + tree3)
		List1.items = (stree1 + stree2)
		
		)
	--drzewa iglaste	
	if(i == 2) then
		(
		
		List2.items = tree2
		List1.items = stree1
		
		)
	--drzewa lisciaste	
	if(i == 3) then
		(
		
		List2.items = tree3
		List1.items = stree2
		
		)
	
	
	)
	
	
	on List1 selected i do
	(
		eFileName.text = Mname
		
		eName.text = List1.selected
		ePar6.text = Mwys as string
		ePar7.text = Msze as string
		ePar8.value = Mrand as integer
		
		
		if loadB.checked == true then
		(
			DirectoryEu = GetDirEu()
			FName = (DirectoryEu + "\\textures\\"+List1.items[i])
		
			if(getFilenameType FName == "") then 
			(
			FName = (DirectoryEu + "\\textures\\"+List1.items[i]+".dds")
			
			if (doesFileExist FName) then FName = (DirectoryEu + "\\textures\\"+List1.items[i]+".tga")
			)
		
		
			if((doesFileExist FName) == true) then 
			(
			if(getFilenameType FName == ".dds") then
				(
				obraz.bitmap = RotateBitmap FName
				)
			else obraz.bitmap = openBitMap FName	
			)
		)
		
		
			
	)

	on List2 selected i do
	(
		eFileName.text = Wname 
		
		eName.text = List2.selected
		ePar6.text = Wwys as string
		ePar7.text = Wsze as string
		ePar8.value = Wrand as integer

		if loadB.checked == true then
		(	
		DirectoryEu = GetDirEu()
		FName = (DirectoryEu + "\\textures\\"+List2.items[i])
		
		
		if(getFilenameType FName == "") then 
		(
		FName = (DirectoryEu + "\\textures\\"+List2.items[i]+".dds")
		if (doesFileExist FName) then FName = (DirectoryEu + "\\textures\\"+List2.items[i]+".tga")
		)
		
		
		if((doesFileExist FName) == true) then 
		(
		if(getFilenameType FName == ".dds") then
			(
			obraz.bitmap = RotateBitmap FName
			)
		else obraz.bitmap = openBitMap FName	
		)
		)		

			
	)

	on List3 selected i do
	(
		eFileName.text = Tname
		
		eName.text = List3.selected
		ePar6.text = Twys as string
		ePar7.text = Tsze as string
		ePar8.value = Trand as integer
		
		
		if loadB.checked == true then
		(		
		DirectoryEu = GetDirEu()
		FName = (DirectoryEu + "\\textures\\"+List3.items[i])
		
		
		if(getFilenameType FName == "") then 
		(
		FName = (DirectoryEu + "\\textures\\"+List3.items[i]+".dds")
		if (doesFileExist FName) then FName = (DirectoryEu + "\\textures\\"+List3.items[i]+".tga")
		)
		
	
		
		if((doesFileExist FName) == true) then 
		(
		if(getFilenameType FName == ".dds") then
			(
			obraz.bitmap = RotateBitmap FName
			)
		else obraz.bitmap = openBitMap FName	
		)
		)
		
			
	)
	
	



)

